/** Copyright 2012
*
* Author: Ismael PONCE GORDILLO
*
* Licensed under the EUPL, Version 1.1 or – as soon they will be
* approved by the European Commission – subsequent versions of the
* EUPL (the "Licence"); you may not use this work except in
* compliance with the Licence.
* You may obtain a copy of the Licence at:
*
* https://joinup.ec.europa.eu/software/page/eupl/licence-eupl
*
* Unless required by applicable law or agreed to in writing,
* software distributed under the Licence is distributed on an "AS
* IS" BASIS, * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either
* express or implied.
* See the Licence for the specific language governing permissions
* and limitations under the Licence.
*/
import java.util.Calendar;
import java.util.Vector;
import org.eclipse.swt.widgets.List;

public class ListConId {
	private Vector<String> identificadores = new Vector<String>();
	private List objetoList = null;
	public List lista() {return objetoList;}
	
	public ListConId(List objetoList) {this.objetoList = objetoList;}
	
	public void borrar(){this.objetoList.removeAll();this.identificadores.clear();}
	public void deSeleccionarTodo() {this.objetoList.deselectAll();}
	public void deshabilitar() {this.objetoList.setEnabled(false);}
	public void habilitar() {this.objetoList.setEnabled(true);}
	public void fijarFoco() {this.objetoList.setFocus();}
	public Integer numeroElementos(){return this.objetoList.getItemCount();}
	public void seleccionarUltimo(){if (this.objetoList.getItemCount()>0) {int i=this.objetoList.getItemCount()-1;this.objetoList.select(i);this.objetoList.setTopIndex(i);}}
	public void seleccionarPrimero(){if (this.objetoList.getItemCount()>0) {this.objetoList.select(0);this.objetoList.setTopIndex(0);}}
	public Vector<Vector<String>> elementosNoSeleccionados(){
		if (PCuaderno.noti) PCuaderno.MiPCuaderno.notificar("()",false);
		Vector<Vector<String>> elementos=new Vector<Vector<String>>();
		for (int i=0;i<this.objetoList.getItemCount();i++) {
			if (!this.objetoList.isSelected(i)) {
				Vector<String> elemento=new Vector<String>();
				elemento.add(this.identificadores.get(i));
				elemento.add(this.objetoList.getItem(i));
				elementos.add(elemento);
			}
			//System.out.println(i+"/"+this.objetoList.getItemCount()+":"+this.identificadores.get(i)+","+this.objetoList.getItem(i)+"=>"+this.objetoList.isSelected(i));
		}
		if (PCuaderno.noti) PCuaderno.MiPCuaderno.notificar("()",true);
		return elementos;
	}
	public String idSeleccionado(){
		String id=null; // Devuelve null si no hay seleccionado (-1)
		if (this.objetoList.getSelectionCount()==1) id=this.identificadores.get(this.objetoList.getSelectionIndex());
		else if (this.objetoList.getSelectionCount()>1) {
			id=this.identificadores.get(this.objetoList.getSelectionIndices()[0]); //Si hay +1 devuelve el 1º
			//for (int i=0;i<this.objetoList.getSelectionCount();i++) System.out.print(this.objetoList.getSelectionIndices()[i]+",");
			//System.out.println("");
		}
		// en linux el getSelectionIndex es el primero de la lista y en windows es el último picado
		return id;
	}
	public Vector<String> idSeleccionados(){
		Vector<String> seleccionados = new Vector<String>();
		if (this.objetoList.getSelectionIndices()!=null) {
			for (int i=0;i<this.objetoList.getSelectionCount();i++) seleccionados.add(this.identificadores.get(this.objetoList.getSelectionIndices()[i]));
			//for (int i=0;i<this.objetoList.getSelectionCount();i++) System.out.print(this.objetoList.getSelectionIndices()[i]+",");
			//System.out.println("");
		}
		return seleccionados;
	}
	public void seleccionarId(String id){
		if (id!=null) {
			this.objetoList.deselectAll();
			this.objetoList.select(identificadores.indexOf(id));
			this.objetoList.setTopIndex(identificadores.indexOf(id));
		}
		if (this.objetoList.getSelectionIndex()<0 && this.objetoList.getItemCount()>0) this.objetoList.select(0);
	}
	public void seleccionarIds(Vector<String> ids){
		this.objetoList.deselectAll();
		if (ids!=null) if (ids.size()>0) {
			int[] indices = new int[ids.size()];
			for (int i=0;i<ids.size();i++) indices[i]=identificadores.indexOf(ids.get(i));
			this.objetoList.select(indices);
			this.objetoList.setTopIndex(indices[0]);
			}
	}
	public String elementoSeleccionado(){
		String elemento=null; // Devuelve null si no hay seleccionado (-1)
		if (this.objetoList.getSelectionIndex()>=0) elemento=this.objetoList.getItem(this.objetoList.getSelectionIndex());
		return elemento;
	}
	public void seleccionarSiguienteOAnterior(){
		if (objetoList!=null) {
			if (objetoList.getItemCount()>1) {
				if (objetoList.getSelectionIndex()<objetoList.getItemCount()-1)
					this.objetoList.select(objetoList.getSelectionIndex()+1);
				else
					this.objetoList.select(objetoList.getSelectionIndex()-1);
			}
		}
	}
	public void addElemento(String id, String elemento){
		this.objetoList.add(elemento);
		this.identificadores.add(id);
	}
	public void rellenarEstudiantesGrupoEval(String idEvaluable,String idEvalEvaluable) {
		if (PCuaderno.noti) PCuaderno.MiPCuaderno.notificar("("+idEvaluable+","+idEvalEvaluable+")",false);
		String idAntiguo=idSeleccionado();
		this.borrar();
		Vector<Vector<String>> estudiantes; 
		if (idEvalEvaluable.equals(""))
			estudiantes = PCuaderno.MiPCuaderno.bbdd.consultarEstudiantesEvalSinGrupoOEvalEvaluable(idEvaluable);
		else
			estudiantes = PCuaderno.MiPCuaderno.bbdd.consultarEstudiantesEvalEvaluable(idEvalEvaluable);
		if (estudiantes!=null)
			for (int i=0;i<estudiantes.size();i++)
				this.addElemento(estudiantes.get(i).get(0),estudiantes.get(i).get(2)+", "+estudiantes.get(i).get(1));
		this.seleccionarId(idAntiguo);
		if (PCuaderno.noti) PCuaderno.MiPCuaderno.notificar("("+idEvaluable+","+idEvalEvaluable+") "+this.objetoList.getItemCount()+" elementos.",true);
	}
	public void rellenarGrupoEvalEvaluable(String idEvaluable) {
		if (PCuaderno.noti) PCuaderno.MiPCuaderno.notificar("("+idEvaluable+")",false);
		this.addElemento("",BBDD.expSinGrupoEvaluacion);
		this.objetoList.select(0);
		Vector<Vector<String>> grupos = PCuaderno.MiPCuaderno.bbdd.consultarEvaluacionesEvaluableGrupos(idEvaluable);
		if (grupos!=null)
			for (int i=0;i<grupos.size();i++) {
				this.addElemento(grupos.get(i).get(0),grupos.get(i).get(4));
				//System.out.println("Añadiendo grupo ("+grupos.get(i).get(0)+") "+grupos.get(i).get(4));
			}
		if (PCuaderno.noti) PCuaderno.MiPCuaderno.notificar("("+idEvaluable+") "+this.objetoList.getItemCount()+" elements.",true);
	}
	public void rellenarParciales(String idMateria){
		if (PCuaderno.noti) PCuaderno.MiPCuaderno.notificar("()",false);
		String idAntiguo=idSeleccionado();
		this.borrar();
		Vector<Vector<String>> parciales = PCuaderno.MiPCuaderno.bbdd.consultarParcial(idMateria,null);
		if (parciales!=null)
			for (int i=0;i<parciales.size();i++) this.addElemento(parciales.get(i).get(0),(i+1)+": "+
				Fecha.formaFechaDia(parciales.get(i).get(2),parciales.get(i).get(3),parciales.get(i).get(4))+" - "+
						Fecha.formaFechaDia(parciales.get(i).get(5),parciales.get(i).get(6),parciales.get(i).get(7)));
		this.seleccionarId(idAntiguo);
		if (PCuaderno.noti) PCuaderno.MiPCuaderno.notificar("() "+this.objetoList.getItemCount()+" elements.",true);
	}
	public void rellenarEvaluables(String idMateriaClase,Integer parcial){
		if (PCuaderno.noti) PCuaderno.MiPCuaderno.notificar("("+idMateriaClase+","+parcial+")");
		Vector<Vector<String>> tabla=null;
		String idAntiguo = this.idSeleccionado();
		this.borrar();
		//System.out.println("rellenando evaluables "+parcial);
		//Parcial.imprimirParciales();
		tabla = PCuaderno.MiPCuaderno.bbdd.consultarEvaluablesMateriaClaseParcial(idMateriaClase,parcial);
		if (tabla!=null)
			for (int i=0;i<tabla.size();i++){
				String texto=null;
				Calendar fecha=Fecha.fechaHora(tabla.get(i).get(3),tabla.get(i).get(2),
						tabla.get(i).get(1),tabla.get(i).get(4),tabla.get(i).get(5));
				if (tabla.get(i).get(12)==null)
					texto=Fecha.formaFechaDiaHora(fecha)+" "+tabla.get(i).get(10)+" "+tabla.get(i).get(6);
				else {
					String idEvaluableEsRecuperado=tabla.get(i).get(12);
					Vector<Vector<String>> evaluableEsRecuperado = null;
					if (idEvaluableEsRecuperado!=null) if (!idEvaluableEsRecuperado.equals(""))
						evaluableEsRecuperado = PCuaderno.MiPCuaderno.bbdd.consultarEvaluable(idEvaluableEsRecuperado);
					texto=Fecha.formaFechaDiaHora(fecha)+" (R)"+evaluableEsRecuperado.get(0).get(9)+" "+tabla.get(i).get(6);
				}
				this.addElemento(tabla.get(i).get(0),texto);
			}
		this.seleccionarId(idAntiguo);
		if (PCuaderno.noti) PCuaderno.MiPCuaderno.notificar("("+idMateriaClase+") "+((tabla!=null)?tabla.size():"null"));
	}
	public void rellenarEvaluablesParaNodo(String idNodo){
		if (PCuaderno.noti) PCuaderno.MiPCuaderno.notificar("("+idNodo+")");
		Vector<Vector<String>> tabla=null;
		String idAntiguo = this.idSeleccionado();
		this.borrar();
		tabla = PCuaderno.MiPCuaderno.bbdd.consultarEvaluablesParaNodoYPadres(idNodo);
		if (tabla!=null)
			for (int i=0;i<tabla.size();i++){
				String texto=null;
				Calendar fecha=Fecha.fechaHora(tabla.get(i).get(3),tabla.get(i).get(2),
						tabla.get(i).get(1),tabla.get(i).get(4),tabla.get(i).get(5));
				if (tabla.get(i).get(12)==null)
					texto=tabla.get(i).get(10)+" "+tabla.get(i).get(6)+" "+Fecha.formaFechaDiaHora(fecha);
				else {
					String idEvaluableEsRecuperado=tabla.get(i).get(12);
					Vector<Vector<String>> evaluableEsRecuperado = null;
					if (idEvaluableEsRecuperado!=null) if (!idEvaluableEsRecuperado.equals(""))
						evaluableEsRecuperado = PCuaderno.MiPCuaderno.bbdd.consultarEvaluable(idEvaluableEsRecuperado);
					texto="(R)"+evaluableEsRecuperado.get(0).get(9)+" "+tabla.get(i).get(6)+" "+Fecha.formaFechaDiaHora(fecha);
				}
				this.addElemento(tabla.get(i).get(0),texto);
			}
		this.seleccionarId(idAntiguo);
		if (PCuaderno.noti) PCuaderno.MiPCuaderno.notificar("("+idNodo+") "+((tabla!=null)?tabla.size():"null"));
	}
	public void rellenarProgramacionNodosArbolDeTrabajo(Integer parcial){
		if (PCuaderno.noti) PCuaderno.MiPCuaderno.notificar("("+parcial+")");
		Vector<String> idAntiguos = this.idSeleccionados();
		this.borrar();  // Antes debe estar actualizado el Arbol de trabajo
		Vector<Vector<String>> nodos = PCuaderno.MiPCuaderno.arbolDeTrabajo.enunciadosNodos(
				PCuaderno.MiPCuaderno.arbolDeTrabajo.idNodosParcial(parcial));
		if (nodos!=null)
			for (int i=0;i<nodos.size();i++)
				this.addElemento(nodos.get(i).get(0),nodos.get(i).get(1));
		this.seleccionarIds(idAntiguos);
		if (PCuaderno.noti) PCuaderno.MiPCuaderno.notificar("("+parcial+") "+((nodos!=null)?nodos.size():"null"));
	}
	public void rellenarProfesores(){
		if (PCuaderno.noti) PCuaderno.MiPCuaderno.notificar("()",false);
		String idAntiguo=idSeleccionado();
		this.borrar();
		Vector<Vector<String>> profesores = PCuaderno.MiPCuaderno.bbdd.consultarProfesor(null);
		if (profesores!=null)
			for (int i=0;i<profesores.size();i++)
				this.addElemento(profesores.get(i).get(0),((profesores.get(i).get(4).equals(BBDD.verdadero))?"("+PCuaderno.MiPCuaderno.mensajes.getString("User")+") ":"")+
					profesores.get(i).get(2)+", "+profesores.get(i).get(1));
		this.seleccionarId(idAntiguo);
		if (PCuaderno.noti) PCuaderno.MiPCuaderno.notificar("() "+this.objetoList.getItemCount()+" elements.",true);
	}
	public void rellenarTiposEvaluables(String idMateria){
		if (PCuaderno.noti) PCuaderno.MiPCuaderno.notificar("()",false);
		String idAntiguo=idSeleccionado();
		this.borrar();
		Vector<Vector<String>> tiposEvaluables = PCuaderno.MiPCuaderno.bbdd.consultarTiposEvaluablesParaMateria(idMateria);
		if (tiposEvaluables!=null)
			for (int i=0;i<tiposEvaluables.size();i++){
				this.addElemento(tiposEvaluables.get(i).get(0), tiposEvaluables.get(i).get(1)+" ("+tiposEvaluables.get(i).get(3)+")");
		}
		this.seleccionarId(idAntiguo);
		if (PCuaderno.noti) PCuaderno.MiPCuaderno.notificar("() "+this.objetoList.getItemCount()+" elements.",true);
	}
	public void rellenarEnsenanzas(){
		if (PCuaderno.noti) PCuaderno.MiPCuaderno.notificar("()",false);
		String idAntiguo=idSeleccionado();
		this.borrar();
		Vector<Vector<String>> ensenanzas = PCuaderno.MiPCuaderno.bbdd.consultarEnsenanza(null);
		if (ensenanzas!=null)
			for (int i=0;i<ensenanzas.size();i++) this.addElemento(ensenanzas.get(i).get(0),ensenanzas.get(i).get(1));
		this.seleccionarId(idAntiguo);
		if (PCuaderno.noti) PCuaderno.MiPCuaderno.notificar("() "+this.objetoList.getItemCount()+" elements.",true);
	}
	public void rellenarTitulos(String idEnsenanza){
		if (PCuaderno.noti) PCuaderno.MiPCuaderno.notificar("("+idEnsenanza+")",false);
		String idAntiguo=idSeleccionado();
		this.borrar();
		if (idEnsenanza!=null) {
			Vector<Vector<String>> titulos = PCuaderno.MiPCuaderno.bbdd.consultarTitulo(idEnsenanza,null);
			if (titulos!=null)
				for (int i=0;i<titulos.size();i++) this.addElemento(titulos.get(i).get(0),titulos.get(i).get(2));
			this.seleccionarId(idAntiguo);
		}
		if (PCuaderno.noti) PCuaderno.MiPCuaderno.notificar("("+idEnsenanza+") "+this.objetoList.getItemCount()+" elements.",true);
	}
	public void rellenarNiveles(String idTitulo){
		if (PCuaderno.noti) PCuaderno.MiPCuaderno.notificar("("+idTitulo+")",false);
		String idAntiguo=idSeleccionado();
		this.borrar();
		if (idTitulo!=null) {
			Vector<Vector<String>> niveles = PCuaderno.MiPCuaderno.bbdd.consultarNivel(idTitulo,null);
			if (niveles!=null)
				for (int i=0;i<niveles.size();i++) this.addElemento(niveles.get(i).get(0),niveles.get(i).get(2));
			this.seleccionarId(idAntiguo);
		}
		if (PCuaderno.noti) PCuaderno.MiPCuaderno.notificar("("+idTitulo+") "+this.objetoList.getItemCount()+" elements.",true);
	}
	public void rellenarClases(String idNivel){
		if (PCuaderno.noti) PCuaderno.MiPCuaderno.notificar("("+idNivel+")",false);
		String idAntiguo=idSeleccionado();
		this.borrar();
		if (idNivel!=null) {
			Vector<Vector<String>> clases = PCuaderno.MiPCuaderno.bbdd.consultarClase(idNivel,null);
			if (clases!=null)
				for (int i=0;i<clases.size();i++) this.addElemento(clases.get(i).get(0),clases.get(i).get(2));
			this.seleccionarId(idAntiguo);
		}
		if (PCuaderno.noti) PCuaderno.MiPCuaderno.notificar("("+idNivel+") "+this.objetoList.getItemCount()+" elements.",true);
	}
	public void rellenarMaterias(String idNivel){
		if (PCuaderno.noti) PCuaderno.MiPCuaderno.notificar("("+idNivel+")",false);
		String idAntiguo=idSeleccionado();
		this.borrar();
		if (idNivel!=null) {
			Vector<Vector<String>> materias = PCuaderno.MiPCuaderno.bbdd.consultarMateria(idNivel,null);
			if (materias!=null)
				for (int i=0;i<materias.size();i++) this.addElemento(materias.get(i).get(0),materias.get(i).get(1));
			this.seleccionarId(idAntiguo);
		}
		if (PCuaderno.noti) PCuaderno.MiPCuaderno.notificar("("+idNivel+") "+this.objetoList.getItemCount()+" elements.",true);
	}
	public void rellenarEstudiantes(String idClase){
		if (PCuaderno.noti) PCuaderno.MiPCuaderno.notificar("("+idClase+")",false);
		String idAntiguo=idSeleccionado();
		this.borrar();
		if (idClase!=null) {
			Vector<Vector<String>> estudiantes = PCuaderno.MiPCuaderno.bbdd.consultarEstudiantesClase(idClase,null);
			if (estudiantes!=null)
				for (int i=0;i<estudiantes.size();i++) this.addElemento(estudiantes.get(i).get(0),estudiantes.get(i).get(1)+", "+estudiantes.get(i).get(2));
			this.seleccionarId(idAntiguo);
		}
		if (PCuaderno.noti) PCuaderno.MiPCuaderno.notificar("("+idClase+") "+this.objetoList.getItemCount()+" elements.",true);
	}
	public void rellenarMatriculados(String idMateria,String idClase){
		if (PCuaderno.noti) PCuaderno.MiPCuaderno.notificar("("+idMateria+","+idClase+")",false);
		String idAntiguo=idSeleccionado();
		this.borrar();
		String idMateriaClase=MateriaClase.getIdMateriaClase(idMateria, idClase);
		if (idMateriaClase!=null) {
			Vector<Vector<String>> matriculados = PCuaderno.MiPCuaderno.bbdd.consultarEstudiantesMateriaClase(idMateriaClase,null);
			if (matriculados!=null)
				for (int i=0;i<matriculados.size();i++) this.addElemento(matriculados.get(i).get(0),matriculados.get(i).get(1)+", "+matriculados.get(i).get(2));
			this.seleccionarId(idAntiguo);
		}
		if (PCuaderno.noti) PCuaderno.MiPCuaderno.notificar("("+idMateria+","+idClase+") "+this.objetoList.getItemCount()+" elements.",true);
	}
	public void rellenarDiasNoLectivos(){
		if (PCuaderno.noti) PCuaderno.MiPCuaderno.notificar("()",false);
		String idAntiguo=idSeleccionado();
		this.borrar();
		Vector<Vector<String>> diasNoLectivos = PCuaderno.MiPCuaderno.bbdd.consultarDiasNoLectivos();
		if (diasNoLectivos!=null)
			for (int i=0;i<diasNoLectivos.size();i++){
				this.addElemento(diasNoLectivos.get(i).get(0),
					Fecha.formaFechaDia(
						Fecha.fecha(diasNoLectivos.get(i).get(2),diasNoLectivos.get(i).get(3),diasNoLectivos.get(i).get(4)))+
						" "+diasNoLectivos.get(i).get(5));
		}
		this.seleccionarId(idAntiguo);
		if (PCuaderno.noti) PCuaderno.MiPCuaderno.notificar("() "+this.objetoList.getItemCount()+" elements.",true);
	}
	public void rellenarUHs(){
		if (PCuaderno.noti) PCuaderno.MiPCuaderno.notificar("()",false);
		String idAntiguo=idSeleccionado();
		this.borrar();
		Vector<Vector<String>> uhs = PCuaderno.MiPCuaderno.bbdd.consultarUH(null,null,true);
		if (uhs!=null)
			for (int i=0;i<uhs.size();i++) {
				Calendar fecha = Calendar.getInstance();
				fecha.set(Calendar.DAY_OF_WEEK, Integer.parseInt(uhs.get(i).get(2)));
				this.addElemento(uhs.get(i).get(0),Fecha.diaCorto(fecha)+" "
						+String.format("%02d",Integer.parseInt(uhs.get(i).get(3)))+":"+String.format("%02d",Integer.parseInt(uhs.get(i).get(4)))+"-"
						+String.format("%02d",Integer.parseInt(uhs.get(i).get(5)))+":"+String.format("%02d",Integer.parseInt(uhs.get(i).get(6)))+" "
						+uhs.get(i).get(7)+" "+uhs.get(i).get(8)+PCuaderno.MiPCuaderno.mensajes.getString("Ordinal")+uhs.get(i).get(9)+" "+uhs.get(i).get(10)+"("+uhs.get(i).get(11)+")");
		}
		this.seleccionarId(idAntiguo);
		if (PCuaderno.noti) PCuaderno.MiPCuaderno.notificar("() "+this.objetoList.getItemCount()+" elements.",true);
	}
	public void rellenaListConIdTutoria(){
		if (PCuaderno.noti) PCuaderno.MiPCuaderno.notificar("()");
		this.borrar();
		//System.out.println("id del usuario = "+PCuaderno.MiPCuaderno.bbdd.consultarIdPropio());
		Vector<Vector<String>> estudiantes = PCuaderno.MiPCuaderno.bbdd.consultarEstudiantesTutoriaProfesor(PCuaderno.MiPCuaderno.bbdd.consultarIdPropio());
		if (estudiantes!=null) {
			for (int i=0;i<estudiantes.size();i++){
				//System.out.println("Añadiendo "+estudiantes.get(i).get(0));
				this.addElemento(estudiantes.get(i).get(0), estudiantes.get(i).get(2)+", "+estudiantes.get(i).get(1));
			}
		}
		if (PCuaderno.noti) PCuaderno.MiPCuaderno.notificar("() "+this.objetoList.getItemCount()+" elements.");
	}
}
