/** Copyright 2012
*
* Author: Ismael PONCE GORDILLO
*
* Licensed under the EUPL, Version 1.1 or – as soon they will be
* approved by the European Commission – subsequent versions of the
* EUPL (the "Licence"); you may not use this work except in
* compliance with the Licence.
* You may obtain a copy of the Licence at:
*
* https://joinup.ec.europa.eu/software/page/eupl/licence-eupl
*
* Unless required by applicable law or agreed to in writing,
* software distributed under the Licence is distributed on an "AS
* IS" BASIS, * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either
* express or implied.
* See the Licence for the specific language governing permissions
* and limitations under the Licence.
*/
import java.io.File;
import java.util.Vector;

import org.eclipse.swt.events.SelectionAdapter;
import org.eclipse.swt.events.SelectionEvent;
import org.eclipse.swt.graphics.Point;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.widgets.Button;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.List;
import org.eclipse.swt.SWT;
import org.eclipse.swt.widgets.FileDialog;
import org.eclipse.swt.widgets.Label;
import org.eclipse.swt.widgets.Group;
import org.eclipse.swt.widgets.Text;
import org.eclipse.swt.widgets.Combo;

public class Matricula extends Composite {
	private Text txtEnsenanzaRef;public Text getTxtEnsenanzaRef(){return txtEnsenanzaRef;}
	private Text txtEnsenanza;public Text getTxtEnsenanza(){return txtEnsenanza;}
	private Text txtTituloRef;public Text getTxtTituloRef(){return txtTituloRef;}
	private Text txtTitulo;public Text getTxtTitulo(){return txtTitulo;}
	private Text txtNivelRef;public Text getTxtNivelRef(){return txtNivelRef;}
	private Text txtClaseRef;public Text getTxtClaseRef(){return txtClaseRef;}
	private Text txtMateriaRef;public Text getTxtMateriaRef(){return txtMateriaRef;}
	private Text txtMateria;public Text getTxtMateria(){return txtMateria;}
	private Text txtEstudianteNombre;public Text getTxtEstudianteNombre(){return txtEstudianteNombre;}
	private Text txtEstudianteApellidos;public Text getTxtEstudianteApellidos(){return txtEstudianteApellidos;}
	private Text txtEstudianteDatos;public Text getTxtEstudianteDatos(){return txtEstudianteDatos;}
	private Button btnEnsenanzaNueva;
	private Button btnEnsenanzaBorrar;
	private Button btnTituloNuevo;
	private Button btnTituloBorrar;
	private Button btnNivelNuevo;
	private Button btnNivelBorrar;
	private Button btnClaseNueva;
	private Button btnClaseBorrar;
	private Button btnMateriaNueva;
	private Button btnMateriaBorrar;
	private Button btnEstudianteNuevo;
	private Button btnEstudianteBorrar;
	private Button btnMatriculadoQuitar;
	private Button btnEstudianteMatricular;
	private Button btnImportarEstudiantes;
	private ListConId listConIdEnsenanzas;
	private ListConId listConIdTitulos;
	private ListConId listConIdNiveles;
	private ListConId listConIdClases;
	private ListConId listConIdEstudiantes;
	private ListConId listConIdMaterias;
	private ListConId listConIdMatriculados;
	private Group grpEstudiantes;
	private Group grpMatriculados;
	private ComboConId comboConIdClaseTutor;
	private final static String TituloEstudiantes=PCuaderno.MiPCuaderno.mensajes.getString("Matricula_Tit_Estudiantes");
	private final static String TituloMatriculados=PCuaderno.MiPCuaderno.mensajes.getString("Matricula_Tit_Matriculados");
	private Composite composite;
	private Composite compositeImportar;
	private Button btnImportarMateria;
	private Button btnImportarNoLectivos;
	private Button btnImportarEventos;
	public Matricula(Composite parent, int style) {
		super(parent, style);
		initialize();
	}
	public void actualizar() {
		actualizarEnsenanzas(MateriaClase.getIdEnsenanzaDeTrabajo());
		actualizarTitulos(MateriaClase.getIdTituloDeTrabajo());
		actualizarNiveles(MateriaClase.getIdNivelDeTrabajo());
		actualizarMaterias(MateriaClase.getIdMateriaDeTrabajo());
		actualizarClases(MateriaClase.getIdClaseDeTrabajo());
	}
	private void initialize() {
		GridLayout gridLayoutMatricula = new GridLayout();
		gridLayoutMatricula.numColumns = 4;
		gridLayoutMatricula.horizontalSpacing = 2;
		gridLayoutMatricula.verticalSpacing = 2;
		gridLayoutMatricula.marginWidth = 2;
		gridLayoutMatricula.marginHeight = 2;
		GridData gridDataMatricula = new GridData();
		gridDataMatricula.grabExcessHorizontalSpace = true;
		gridDataMatricula.grabExcessVerticalSpace = true;
		gridDataMatricula.horizontalAlignment = GridData.FILL;
		gridDataMatricula.verticalAlignment = GridData.FILL;
		this.setLayoutData(gridDataMatricula);
		this.setLayout(gridLayoutMatricula);
		this.setSize(new Point(685, 340));
		
		Group grpEnsenanzas = new Group(this, SWT.NONE);
		grpEnsenanzas.setText(PCuaderno.MiPCuaderno.mensajes.getString("Matricula_GrpEnsenanzas_Text"));
		GridLayout gl_grpEnsenanzas = new GridLayout(2, false);
		gl_grpEnsenanzas.verticalSpacing = 2;
		gl_grpEnsenanzas.marginWidth = 2;
		gl_grpEnsenanzas.marginHeight = 2;
		gl_grpEnsenanzas.horizontalSpacing = 2;
		grpEnsenanzas.setLayout(gl_grpEnsenanzas);
		GridData gd_grpEnsenanzas = new GridData(SWT.FILL, SWT.FILL, true, true, 1, 2);
		gd_grpEnsenanzas.heightHint = 125;
		grpEnsenanzas.setLayoutData(gd_grpEnsenanzas);
		
		List listEnsenanzas = new List(grpEnsenanzas, SWT.BORDER | SWT.V_SCROLL);
		listEnsenanzas.setToolTipText(PCuaderno.MiPCuaderno.mensajes.getString("Matricula_ListEnsenanzas_ToolTip"));
		listEnsenanzas.addSelectionListener(new SelectionAdapter() {
			public void widgetSelected(SelectionEvent e) {
				if (PCuaderno.noti) PCuaderno.MiPCuaderno.notificar("listEnsenanzas "+listConIdEnsenanzas.idSeleccionado());
				actualizarDatosEnsenanza();
			}
		});
		GridData gd_listEnsenanzas = new GridData(SWT.FILL, SWT.FILL, true, true, 1, 3);
		gd_listEnsenanzas.widthHint = 60;
		gd_listEnsenanzas.heightHint = 55;
		listEnsenanzas.setLayoutData(gd_listEnsenanzas);
		listConIdEnsenanzas = new ListConId(listEnsenanzas);
		
		Label lblEnsenanzaRef = new Label(grpEnsenanzas, SWT.NONE);
		lblEnsenanzaRef.setLayoutData(new GridData(SWT.RIGHT, SWT.CENTER, false, false, 1, 1));
		lblEnsenanzaRef.setText(PCuaderno.MiPCuaderno.mensajes.getString("Matricula_LblEnsenanzaRef_Text"));
		
		txtEnsenanzaRef = new Text(grpEnsenanzas, SWT.BORDER);
		txtEnsenanzaRef.setToolTipText(PCuaderno.MiPCuaderno.mensajes.getString("Matricula_TxtEnsenanzaRef_ToolTip"));
		txtEnsenanzaRef.setText("XXXXX");
		GridData gd_textEnsenanzaRef = new GridData(SWT.FILL, SWT.CENTER, true, false, 1, 1);
		gd_textEnsenanzaRef.widthHint = 55;
		txtEnsenanzaRef.setLayoutData(gd_textEnsenanzaRef);
		TextoDemorado.add(txtEnsenanzaRef,false,5,null,null,false,listConIdEnsenanzas,null);
		
		Composite compositeEnsenanzasNuevoBorrar = new Composite(grpEnsenanzas, SWT.NONE);
		compositeEnsenanzasNuevoBorrar.setLayoutData(new GridData(SWT.LEFT, SWT.BOTTOM, false, false, 1, 1));
		GridLayout gl_compositeEnsenanzasNuevoBorrar = new GridLayout(1, false);
		gl_compositeEnsenanzasNuevoBorrar.verticalSpacing = 2;
		gl_compositeEnsenanzasNuevoBorrar.marginWidth = 2;
		gl_compositeEnsenanzasNuevoBorrar.marginHeight = 2;
		gl_compositeEnsenanzasNuevoBorrar.horizontalSpacing = 2;
		compositeEnsenanzasNuevoBorrar.setLayout(gl_compositeEnsenanzasNuevoBorrar);
		
		btnEnsenanzaNueva = new Button(compositeEnsenanzasNuevoBorrar, SWT.NONE);
		btnEnsenanzaNueva.setToolTipText(PCuaderno.MiPCuaderno.mensajes.getString("Matricula_BtnEnsenanzaNueva_ToolTip"));
		btnEnsenanzaNueva.addSelectionListener(new SelectionAdapter() {
			public void widgetSelected(SelectionEvent e) {
				if (PCuaderno.noti) PCuaderno.MiPCuaderno.notificar("btnEnsenanzaNueva");
				String id = PCuaderno.MiPCuaderno.bbdd.insertarEnsenanza(PCuaderno.MiPCuaderno.mensajes.getString("Matricula_BtnEnsenanzaNueva_Nueva"), "");
				actualizarEnsenanzas(id);
				txtEnsenanzaRef.setFocus();
				txtEnsenanzaRef.selectAll();
			}
		});
		btnEnsenanzaNueva.setText(PCuaderno.MiPCuaderno.mensajes.getString("Matricula_BtnEnsenanzaNueva_Text"));
		
		btnEnsenanzaBorrar = new Button(compositeEnsenanzasNuevoBorrar, SWT.NONE);
		btnEnsenanzaBorrar.setToolTipText(PCuaderno.MiPCuaderno.mensajes.getString("Matricula_BtnEnsenanzaBorrar_ToolTip"));
		btnEnsenanzaBorrar.addSelectionListener(new SelectionAdapter() {
			public void widgetSelected(SelectionEvent e) {
				if (PCuaderno.noti) PCuaderno.MiPCuaderno.notificar("btnEnsenanzaBorrar");
				Vector<Vector<String>> titulos=PCuaderno.MiPCuaderno.bbdd.consultarTitulo(listConIdEnsenanzas.idSeleccionado(), null);
				if (titulos!=null) if (titulos.size()>0) {
					String m=PCuaderno.MiPCuaderno.mensajes.getString("Matricula_BtnEnsenanzaBorrar_Info_Tit");
					PCuaderno.MiPCuaderno.informacion(m);
				} else {
					PCuaderno.MiPCuaderno.bbdd.borrarEnsenanza(listConIdEnsenanzas.idSeleccionado());
					actualizarEnsenanzas(null);
				}
			}
		});
		btnEnsenanzaBorrar.setText(PCuaderno.MiPCuaderno.mensajes.getString("Matricula_BtnEnsenanzaBorrar_Text"));
		
		txtEnsenanza = new Text(grpEnsenanzas, SWT.BORDER);
		txtEnsenanza.setToolTipText(PCuaderno.MiPCuaderno.mensajes.getString("Matricula_TxtEnsenanza_ToolTip"));
		txtEnsenanza.setLayoutData(new GridData(SWT.FILL, SWT.CENTER, true, false, 2, 1));
		TextoDemorado.add(txtEnsenanza,false,1024,null,null,true,listConIdEnsenanzas,null);
		
		Group grpNiveles = new Group(this, SWT.NONE);
		grpNiveles.setLayoutData(new GridData(SWT.FILL, SWT.FILL, true, true, 1, 1));
		grpNiveles.setText(PCuaderno.MiPCuaderno.mensajes.getString("Matricula_GrpNiveles_Text"));
		GridLayout gl_grpNiveles = new GridLayout(2, false);
		gl_grpNiveles.horizontalSpacing = 2;
		gl_grpNiveles.marginHeight = 2;
		gl_grpNiveles.marginWidth = 2;
		gl_grpNiveles.verticalSpacing = 2;
		grpNiveles.setLayout(gl_grpNiveles);
		
		List listNiveles = new List(grpNiveles, SWT.BORDER | SWT.V_SCROLL);
		listNiveles.setToolTipText(PCuaderno.MiPCuaderno.mensajes.getString("Matricula_ListNiveles_ToolTip"));
		listNiveles.addSelectionListener(new SelectionAdapter() {
			public void widgetSelected(SelectionEvent e) {
				if (PCuaderno.noti) PCuaderno.MiPCuaderno.notificar("listNiveles "+listConIdNiveles.idSeleccionado());
				actualizarDatosNivel();
			}
		});
		GridData gd_listNiveles = new GridData(SWT.FILL, SWT.FILL, true, true, 1, 3);
		gd_listNiveles.widthHint = 50;
		gd_listNiveles.heightHint = 40;
		listNiveles.setLayoutData(gd_listNiveles);
		listConIdNiveles = new ListConId(listNiveles);
		
		Label lblNivelRef = new Label(grpNiveles, SWT.NONE);
		lblNivelRef.setLayoutData(new GridData(SWT.RIGHT, SWT.CENTER, false, false, 1, 1));
		lblNivelRef.setText(PCuaderno.MiPCuaderno.mensajes.getString("Matricula_LblNivelRef_Text"));
		
		txtNivelRef = new Text(grpNiveles, SWT.BORDER);
		txtNivelRef.setToolTipText(PCuaderno.MiPCuaderno.mensajes.getString("Matricula_TxtNivelRef_ToolTip"));
		txtNivelRef.setText("XXX");
		GridData gd_txtNivel = new GridData(SWT.FILL, SWT.CENTER, true, false, 1, 1);
		gd_txtNivel.widthHint = 40;
		txtNivelRef.setLayoutData(gd_txtNivel);
		TextoDemorado.add(txtNivelRef,false,3,null,null,false,listConIdNiveles,null);
		
		Composite compositeNivelNuevoBorrar = new Composite(grpNiveles, SWT.NONE);
		compositeNivelNuevoBorrar.setLayoutData(new GridData(SWT.LEFT, SWT.BOTTOM, false, false, 1, 1));
		GridLayout gl_compositeNivelNuevoBorrar = new GridLayout(1, false);
		gl_compositeNivelNuevoBorrar.verticalSpacing = 2;
		gl_compositeNivelNuevoBorrar.marginWidth = 2;
		gl_compositeNivelNuevoBorrar.marginHeight = 2;
		gl_compositeNivelNuevoBorrar.horizontalSpacing = 2;
		compositeNivelNuevoBorrar.setLayout(gl_compositeNivelNuevoBorrar);
		
		btnNivelNuevo = new Button(compositeNivelNuevoBorrar, SWT.NONE);
		btnNivelNuevo.setToolTipText(PCuaderno.MiPCuaderno.mensajes.getString("Matricula_BtnNivelNuevo_ToolTip"));
		btnNivelNuevo.addSelectionListener(new SelectionAdapter() {
			public void widgetSelected(SelectionEvent e) {
				if (PCuaderno.noti) PCuaderno.MiPCuaderno.notificar("btnNivelNuevo");
				String id = PCuaderno.MiPCuaderno.bbdd.insertarNivel(listConIdTitulos.idSeleccionado(),"999");
				actualizarNiveles(id);
				txtNivelRef.setFocus();
				txtNivelRef.selectAll();
			}
		});
		btnNivelNuevo.setText(PCuaderno.MiPCuaderno.mensajes.getString("Matricula_BtnNivelNuevo_Text"));
		
		btnNivelBorrar = new Button(compositeNivelNuevoBorrar, SWT.NONE);
		btnNivelBorrar.setToolTipText(PCuaderno.MiPCuaderno.mensajes.getString("Matricula_BtnNivelBorrar_ToolTip"));
		btnNivelBorrar.addSelectionListener(new SelectionAdapter() {
			public void widgetSelected(SelectionEvent e) {
				if (PCuaderno.noti) PCuaderno.MiPCuaderno.notificar("btnNivelBorrar");
				Vector<Vector<String>> clases=PCuaderno.MiPCuaderno.bbdd.consultarClase(listConIdNiveles.idSeleccionado(), null);
				Vector<Vector<String>> materias=PCuaderno.MiPCuaderno.bbdd.consultarMateria(listConIdNiveles.idSeleccionado(), null);
				Vector<Vector<String>> estudiantes=PCuaderno.MiPCuaderno.bbdd.consultarClase(listConIdNiveles.idSeleccionado(), null);
				if (clases!=null) if (clases.size()>0) {
					String m=PCuaderno.MiPCuaderno.mensajes.getString("Matricula_BtnNivelBorrar_Info_Clase");
					PCuaderno.MiPCuaderno.informacion(m);
				} else if (materias!=null) if (materias.size()>0) {
					String m=PCuaderno.MiPCuaderno.mensajes.getString("Matricula_BtnNivelBorrar_Info_Materia");
					PCuaderno.MiPCuaderno.informacion(m);
				} else if (estudiantes!=null) if (estudiantes.size()>0) {
					String m=PCuaderno.MiPCuaderno.mensajes.getString("Matricula_BtnNivelBorrar_Info_Estudiante");
					PCuaderno.MiPCuaderno.informacion(m);
				} else {
					PCuaderno.MiPCuaderno.bbdd.borrarNivel(listConIdNiveles.idSeleccionado());
					actualizarNiveles(null);
				}
			}
		});
		btnNivelBorrar.setText(PCuaderno.MiPCuaderno.mensajes.getString("Matricula_BtnNivelBorrar_Text"));
		
		Group grpClases = new Group(this, SWT.NONE);
		GridData gd_grpClases = new GridData(SWT.FILL, SWT.FILL, true, true, 1, 1);
		gd_grpClases.minimumHeight = 150;
		gd_grpClases.heightHint = 125;
		grpClases.setLayoutData(gd_grpClases);
		grpClases.setText(PCuaderno.MiPCuaderno.mensajes.getString("Matricula_GrpClases_Text"));
		GridLayout gl_grpClases = new GridLayout(3, false);
		gl_grpClases.verticalSpacing = 2;
		gl_grpClases.marginWidth = 2;
		gl_grpClases.marginHeight = 2;
		gl_grpClases.horizontalSpacing = 2;
		grpClases.setLayout(gl_grpClases);
		
		List listClases = new List(grpClases, SWT.BORDER | SWT.V_SCROLL);
		listClases.setToolTipText(PCuaderno.MiPCuaderno.mensajes.getString("Matricula_ListClases_ToolTip"));
		listClases.addSelectionListener(new SelectionAdapter() {
			public void widgetSelected(SelectionEvent e) {
				if (PCuaderno.noti) PCuaderno.MiPCuaderno.notificar("listClases "+listConIdClases.idSeleccionado());
				actualizarDatosClase();
				MateriaClase.fijarMateriaClaseParaClase(listConIdMaterias.idSeleccionado(), listConIdClases.idSeleccionado());
				actualizarEstudiantes(null);
				actualizarMatriculados(null);
			}
		});
		GridData gd_listClases = new GridData(SWT.FILL, SWT.FILL, true, true, 1, 3);
		gd_listClases.heightHint = 55;
		gd_listClases.widthHint = 60;
		listClases.setLayoutData(gd_listClases);
		listConIdClases = new ListConId(listClases);
		
		Label lblClaseRef = new Label(grpClases, SWT.NONE);
		lblClaseRef.setLayoutData(new GridData(SWT.RIGHT, SWT.CENTER, false, false, 1, 1));
		lblClaseRef.setText(PCuaderno.MiPCuaderno.mensajes.getString("Matricula_LblClaseRef_Text"));
		
		txtClaseRef = new Text(grpClases, SWT.BORDER);
		txtClaseRef.setToolTipText(PCuaderno.MiPCuaderno.mensajes.getString("Matricula_TxtClaseRef_ToolTip"));
		txtClaseRef.setText("XXXXX");
		GridData gd_txtClaseRef = new GridData(SWT.FILL, SWT.CENTER, true, false, 1, 1);
		gd_txtClaseRef.widthHint = 55;
		txtClaseRef.setLayoutData(gd_txtClaseRef);
		TextoDemorado.add(txtClaseRef,false,5,null,null,false,listConIdClases,null);
		
		Composite compositeClaseNuevoBorrar = new Composite(grpClases, SWT.NONE);
		compositeClaseNuevoBorrar.setLayoutData(new GridData(SWT.LEFT, SWT.TOP, false, false, 2, 1));
		GridLayout gl_compositeClaseNuevoBorrar = new GridLayout(1, false);
		gl_compositeClaseNuevoBorrar.verticalSpacing = 2;
		gl_compositeClaseNuevoBorrar.marginWidth = 2;
		gl_compositeClaseNuevoBorrar.marginHeight = 2;
		gl_compositeClaseNuevoBorrar.horizontalSpacing = 2;
		compositeClaseNuevoBorrar.setLayout(gl_compositeClaseNuevoBorrar);
		
		btnClaseNueva = new Button(compositeClaseNuevoBorrar, SWT.NONE);
		btnClaseNueva.setToolTipText(PCuaderno.MiPCuaderno.mensajes.getString("Matricula_BtnClaseNueva_ToolTip"));
		btnClaseNueva.addSelectionListener(new SelectionAdapter() {
			public void widgetSelected(SelectionEvent e) {
				if (PCuaderno.noti) PCuaderno.MiPCuaderno.notificar("btnClaseNueva");
				String id = PCuaderno.MiPCuaderno.bbdd.insertarClase(listConIdNiveles.idSeleccionado(),"X");
				if (id==null || Integer.valueOf(id)<0) {
					String m=PCuaderno.MiPCuaderno.mensajes.getString("Matricula_BtnClaseNueva_Error_Profe");
					PCuaderno.MiPCuaderno.error(m);
				} else {
					actualizarClases(id);
					actualizarEstudiantes(null);
					txtClaseRef.setFocus();
					txtClaseRef.selectAll();
				}
			}
		});
		btnClaseNueva.setText(PCuaderno.MiPCuaderno.mensajes.getString("Matricula_BtnClaseNueva_Text"));
		
		btnClaseBorrar = new Button(compositeClaseNuevoBorrar, SWT.NONE);
		btnClaseBorrar.setToolTipText(PCuaderno.MiPCuaderno.mensajes.getString("Matricula_BtnClaseBorrar_ToolTip"));
		btnClaseBorrar.addSelectionListener(new SelectionAdapter() {
			public void widgetSelected(SelectionEvent e) {
				if (PCuaderno.noti) PCuaderno.MiPCuaderno.notificar("btnClaseBorrar");
				boolean tieneHorario=false;
				Vector<Vector<String>> materiasClases = PCuaderno.MiPCuaderno.bbdd.consultarIdMateriaClases(null,listConIdClases.idSeleccionado());
				for (int i=0;i<materiasClases.size();i++) {
					tieneHorario=!PCuaderno.MiPCuaderno.bbdd.consultarUHvacio(materiasClases.get(i).get(0));
					if (tieneHorario==true) break;
				}
				boolean vacia=true;
				Vector<Vector<String>> estudiantes=PCuaderno.MiPCuaderno.bbdd.consultarEstudiantesClase(listConIdClases.idSeleccionado(), null);
				if (estudiantes!=null) if (estudiantes.size()>0) {
					String m=PCuaderno.MiPCuaderno.mensajes.getString("Matricula_BtnClaseBorrar_Info_Estudiante");
					PCuaderno.MiPCuaderno.informacion(m);
					vacia=false;
				}
				if (tieneHorario) {
					String m=PCuaderno.MiPCuaderno.mensajes.getString("Matricula_BtnClaseBorrar_Info_Horario");
					PCuaderno.MiPCuaderno.informacion(m);
					vacia=false;
				} 
				if (vacia) {
					String m=PCuaderno.MiPCuaderno.mensajes.getString("Matricula_BtnClaseBorrar_Preg_Seguro");
					int buttonID = PCuaderno.MiPCuaderno.pregunta(m);
					if (buttonID == SWT.OK) {
						PCuaderno.MiPCuaderno.bbdd.borrarClase(listConIdClases.idSeleccionado());
						//actualizar horario
						actualizarClases(null);
						MateriaClase.fijarMateriaClaseParaClase(listConIdMaterias.idSeleccionado(), listConIdClases.idSeleccionado());
						actualizarEstudiantes(null);
					}
				}
			}
		});
		btnClaseBorrar.setText(PCuaderno.MiPCuaderno.mensajes.getString("Matricula_BtnClaseBorrar_Text"));
		
		Label lblClaseTutor = new Label(grpClases, SWT.NONE);
		lblClaseTutor.setLayoutData(new GridData(SWT.RIGHT, SWT.BOTTOM, false, false, 2, 1));
		lblClaseTutor.setText(PCuaderno.MiPCuaderno.mensajes.getString("Matricula_lblClaseTutor_Text"));
		
		Combo comboClaseTutor = new Combo(grpClases, SWT.NONE | SWT.READ_ONLY);
		comboClaseTutor.setToolTipText(PCuaderno.MiPCuaderno.mensajes.getString("Matricula_ComboClaseTutor_ToolTip"));
		GridData gd_combo = new GridData(SWT.FILL, SWT.CENTER, true, false, 3, 1);
		gd_combo.widthHint = 150;
		comboClaseTutor.setLayoutData(gd_combo);
		comboConIdClaseTutor = new ComboConId(comboClaseTutor);
		comboClaseTutor.addSelectionListener(new SelectionAdapter() {
			public void widgetSelected(SelectionEvent e) {
				if (PCuaderno.noti) PCuaderno.MiPCuaderno.notificar("comboClaseTutor");
				PCuaderno.MiPCuaderno.bbdd.modificarClaseTutor(listConIdClases.idSeleccionado(), comboConIdClaseTutor.idSeleccionado());
			}
		});
		
		Group grpMaterias = new Group(this, SWT.NONE);
		GridLayout gl_grpMaterias = new GridLayout(3, false);
		gl_grpMaterias.verticalSpacing = 2;
		gl_grpMaterias.marginWidth = 2;
		gl_grpMaterias.marginHeight = 2;
		gl_grpMaterias.horizontalSpacing = 2;
		grpMaterias.setLayout(gl_grpMaterias);
		GridData gd_grpMaterias = new GridData(SWT.FILL, SWT.FILL, true, true, 1, 2);
		gd_grpMaterias.heightHint = 125;
		grpMaterias.setLayoutData(gd_grpMaterias);
		grpMaterias.setText(PCuaderno.MiPCuaderno.mensajes.getString("Matricula_GrpMaterias_Text"));
		
		List listMaterias = new List(grpMaterias, SWT.BORDER | SWT.V_SCROLL);
		listMaterias.setToolTipText(PCuaderno.MiPCuaderno.mensajes.getString("Matricula_ListMaterias_ToolTip"));
		listMaterias.addSelectionListener(new SelectionAdapter() {
			public void widgetSelected(SelectionEvent e) {
				if (PCuaderno.noti) PCuaderno.MiPCuaderno.notificar("listMaterias "+listConIdMaterias.idSeleccionado());
				actualizarDatosMateria();
				MateriaClase.fijarMateriaClaseParaMateria(listConIdMaterias.idSeleccionado(), listConIdClases.idSeleccionado());
				actualizarMatriculados(null);
			}
		});
		GridData gd_listMaterias = new GridData(SWT.FILL, SWT.FILL, true, true, 1, 2);
		gd_listMaterias.widthHint = 60;
		gd_listMaterias.heightHint = 55;
		listMaterias.setLayoutData(gd_listMaterias);
		listConIdMaterias = new ListConId(listMaterias);
		
		Label lblMateriaRef = new Label(grpMaterias, SWT.NONE);
		lblMateriaRef.setLayoutData(new GridData(SWT.RIGHT, SWT.CENTER, false, false, 1, 1));
		lblMateriaRef.setText(PCuaderno.MiPCuaderno.mensajes.getString("Matricula_LblMateriaRef_Text"));
		
		txtMateriaRef = new Text(grpMaterias, SWT.BORDER);
		txtMateriaRef.setToolTipText(PCuaderno.MiPCuaderno.mensajes.getString("Matricula_TxtMateriaRef_ToolTip"));
		txtMateriaRef.setText("XXXXX");
		GridData gd_txtMateriaRef = new GridData(SWT.FILL, SWT.CENTER, true, false, 1, 1);
		gd_txtMateriaRef.widthHint = 55;
		txtMateriaRef.setLayoutData(gd_txtMateriaRef);
		TextoDemorado.add(txtMateriaRef,false,5,null,null,false,listConIdMaterias,null);
		
		Composite compositeMateriaNuevoBorrar = new Composite(grpMaterias, SWT.NONE);
		compositeMateriaNuevoBorrar.setLayoutData(new GridData(SWT.LEFT, SWT.TOP, false, false, 2, 1));
		GridLayout gl_compositeMateriaNuevoBorrar = new GridLayout(1, false);
		gl_compositeMateriaNuevoBorrar.verticalSpacing = 2;
		gl_compositeMateriaNuevoBorrar.marginWidth = 2;
		gl_compositeMateriaNuevoBorrar.marginHeight = 2;
		gl_compositeMateriaNuevoBorrar.horizontalSpacing = 2;
		compositeMateriaNuevoBorrar.setLayout(gl_compositeMateriaNuevoBorrar);
		
		btnMateriaNueva = new Button(compositeMateriaNuevoBorrar, SWT.NONE);
		btnMateriaNueva.setToolTipText(PCuaderno.MiPCuaderno.mensajes.getString("Matricula_BtnMateriaNueva_ToolTip"));
		btnMateriaNueva.addSelectionListener(new SelectionAdapter() {
			public void widgetSelected(SelectionEvent e) {
				if (PCuaderno.noti) PCuaderno.MiPCuaderno.notificar("btnMateriaNueva");
				String id = PCuaderno.MiPCuaderno.bbdd.insertarMateria(listConIdNiveles.idSeleccionado(),PCuaderno.MiPCuaderno.mensajes.getString("Matricula_BtnClaseNueva_Nueva"),"");
				actualizarMaterias(id);
				MateriaClase.fijarMateriaClaseParaMateria(listConIdMaterias.idSeleccionado(), listConIdClases.idSeleccionado());				
				actualizarMatriculados(null);
				txtMateriaRef.setFocus();
				txtMateriaRef.selectAll();
			}
		});
		btnMateriaNueva.setText(PCuaderno.MiPCuaderno.mensajes.getString("Matricula_BtnClaseNueva_Text"));
		
		btnMateriaBorrar = new Button(compositeMateriaNuevoBorrar, SWT.NONE);
		btnMateriaBorrar.setToolTipText(PCuaderno.MiPCuaderno.mensajes.getString("Matricula_BtnMateriaBorrar_ToolTip"));
		btnMateriaBorrar.addSelectionListener(new SelectionAdapter() {
			public void widgetSelected(SelectionEvent e) {
				if (PCuaderno.noti) PCuaderno.MiPCuaderno.notificar("btnMateriaBorrar");
				boolean vacia=true;
				Vector<Vector<String>> estudiantes=PCuaderno.MiPCuaderno.bbdd.consultarEstudiantesMateria(listConIdMaterias.idSeleccionado(), null);
				Vector<Vector<String>> tiposEvaluables=PCuaderno.MiPCuaderno.bbdd.consultarTiposEvaluablesParaMateria(listConIdMaterias.idSeleccionado());
				boolean tieneHorario=false;
				Vector<Vector<String>> materiasClases = PCuaderno.MiPCuaderno.bbdd.consultarIdMateriaClases(listConIdMaterias.idSeleccionado(), null);
				for (int i=0;i<materiasClases.size();i++) {
					tieneHorario=!PCuaderno.MiPCuaderno.bbdd.consultarUHvacio(materiasClases.get(i).get(0));
					if (tieneHorario==true) break;
				}
				if (estudiantes!=null) if (estudiantes.size()>0) {
					String m=PCuaderno.MiPCuaderno.mensajes.getString("Matricula_BtnMateriaBorrar_Info_Estudiante");
					PCuaderno.MiPCuaderno.informacion(m);
					vacia=false;
				}
				if (tiposEvaluables!=null) if (tiposEvaluables.size()>0) {
					String m=PCuaderno.MiPCuaderno.mensajes.getString("Matricula_BtnMateriaBorrar_Info_TipoEvaluable");
					PCuaderno.MiPCuaderno.informacion(m);
					vacia=false;
				}
				if (tieneHorario) {
					String m=PCuaderno.MiPCuaderno.mensajes.getString("Matricula_BtnMateriaBorrar_Info_Horario");
					PCuaderno.MiPCuaderno.informacion(m);
					vacia=false;
				} 
				if (vacia) {
					String m=PCuaderno.MiPCuaderno.mensajes.getString("Matricula_BtnMateriaBorrar_Preg_Seguro");
					int buttonID = PCuaderno.MiPCuaderno.pregunta(m);
					if (buttonID == SWT.OK) {
						PCuaderno.MiPCuaderno.bbdd.borrarMateria(listConIdMaterias.idSeleccionado());
						//actualizar horario
						actualizarMaterias(null);
						MateriaClase.fijarMateriaClaseParaMateria(listConIdMaterias.idSeleccionado(), listConIdClases.idSeleccionado());
						actualizarEstudiantes(null);
					}
				}
			}
		});
		btnMateriaBorrar.setText(PCuaderno.MiPCuaderno.mensajes.getString("Matricula_BtnClaseBorrar_Text"));
		
		txtMateria = new Text(grpMaterias, SWT.BORDER);
		txtMateria.setToolTipText(PCuaderno.MiPCuaderno.mensajes.getString("Matricula_TxtMateria_ToolTip"));
		txtMateria.setLayoutData(new GridData(SWT.FILL, SWT.CENTER, true, false, 3, 1));
		TextoDemorado.add(txtMateria,false,256,null,null,true,listConIdMaterias,null);
		
		compositeImportar = new Composite(this, SWT.NONE);
		GridLayout gl_compositeImportar = new GridLayout(4, false);
		gl_compositeImportar.marginWidth = 1;
		gl_compositeImportar.marginHeight = 1;
		gl_compositeImportar.verticalSpacing = 1;
		compositeImportar.setLayout(gl_compositeImportar);
		GridData gd_compositeImportar = new GridData(SWT.FILL, SWT.CENTER, true, false, 2, 1);
		gd_compositeImportar.minimumHeight = 25;
		compositeImportar.setLayoutData(gd_compositeImportar);
		
		btnImportarEstudiantes = new Button(compositeImportar, SWT.NONE);
		btnImportarEstudiantes.setLayoutData(new GridData(SWT.LEFT, SWT.CENTER, true, false, 1, 1));
		btnImportarEstudiantes.setToolTipText(PCuaderno.MiPCuaderno.mensajes.getString("Matricula_BtnImportarEstudiantes_ToolTip"));
		btnImportarEstudiantes.setText(PCuaderno.MiPCuaderno.mensajes.getString("Matricula_BtnImportarEstudiantes_Text"));
		btnImportarEstudiantes.addSelectionListener(new SelectionAdapter() {
			public void widgetSelected(SelectionEvent e) {
				if (PCuaderno.noti) PCuaderno.MiPCuaderno.notificar("btnImportarEstudiantes");
				String m=PCuaderno.MiPCuaderno.mensajes.getString("Matricula_BtnImportarEstudiantes_Preg_Seguro");
				int buttonID = PCuaderno.MiPCuaderno.pregunta(m);
				if (buttonID == SWT.OK) {
					m=PCuaderno.MiPCuaderno.mensajes.getString("Matricula_BtnImportarEstudiantes_Preg_Cabecera");
					buttonID = PCuaderno.MiPCuaderno.pregunta(m);
			        FileDialog fd = new FileDialog(PCuaderno.MiPCuaderno.shellPrincipal, SWT.OPEN);
			        fd.setText("Importar estudiantes desde");
			        fd.setFilterPath(PCuaderno.MiPCuaderno.bbdd.dirBBDD+File.separatorChar);
			        String[] filterExt = { "*.csv","*.txt","*.*" };
			        fd.setFilterExtensions(filterExt);
			        String nomArchivo = fd.open();
					PCuaderno.MiPCuaderno.bbdd.importarEstudiantes(nomArchivo,MateriaClase.getIdClaseDeTrabajo(),(buttonID == SWT.OK));
					actualizarEstudiantes(null);
					listConIdEstudiantes.deSeleccionarTodo();
					listConIdEstudiantes.seleccionarUltimo();
				}
			}
		});
						
		btnImportarMateria = new Button(compositeImportar, SWT.NONE);
		btnImportarMateria.setLayoutData(new GridData(SWT.CENTER, SWT.CENTER, true, false, 1, 1));
		btnImportarMateria.setText(PCuaderno.MiPCuaderno.mensajes.getString("Matricula_BtnImportarMateria_Text"));
		btnImportarMateria.setToolTipText(PCuaderno.MiPCuaderno.mensajes.getString("Matricula_BtnImportarMateria_ToolTip"));
		btnImportarMateria.addSelectionListener(new SelectionAdapter() {
			public void widgetSelected(SelectionEvent e) {
				if (PCuaderno.noti) PCuaderno.MiPCuaderno.notificar("btnImportarMateria");
				String m=PCuaderno.MiPCuaderno.mensajes.getString("Matricula_BtnImportarMateria_Preg_Copia");
				int buttonID = PCuaderno.MiPCuaderno.pregunta(m);
				if (buttonID != SWT.OK) {
					if (PCuaderno.MiPCuaderno.bbdd.bbddBackupHacer()) {
						m=PCuaderno.MiPCuaderno.mensajes.getString("Mantenimiento_BtnAlmacenHacer_Inf_Backup");
						PCuaderno.MiPCuaderno.informacion(m);
					} else {
						m=PCuaderno.MiPCuaderno.mensajes.getString("Mantenimiento_BtnAlmacenHacer_Err_Backup");
						PCuaderno.MiPCuaderno.error(m);
					}
				}
		        FileDialog fd = new FileDialog(PCuaderno.MiPCuaderno.shellPrincipal, SWT.OPEN);
		        fd.setText(PCuaderno.MiPCuaderno.mensajes.getString("Matricula_BtnImportarMateria_Sel_Text"));
		        fd.setFilterPath(PCuaderno.MiPCuaderno.bbdd.dirBBDD+File.separatorChar);
		        String[] filterExt = { "*.zip","*.*" };
		        fd.setFilterExtensions(filterExt);
		        String nomArchivo = fd.open();
		        if (nomArchivo!=null) {
		        	if (!BBDD.bbddPreparaTemporal(nomArchivo)) {
						String me=PCuaderno.MiPCuaderno.mensajes.getString("Matricula_BtnImportarMateria_Err_NoBackup");
						PCuaderno.MiPCuaderno.informacion(me);
		        	} else {
						String acceso="";
						boolean comprobada=false;
						PCuaderno.MiPCuaderno.bbdd_temporal.conexionFijaCadenaPlana();
						if (!PCuaderno.MiPCuaderno.bbdd_temporal.conexionComprobar()) {
							if (PCuaderno.noti) PCuaderno.MiPCuaderno.notificar("Asking password...");
							acceso=PCuaderno.MiPCuaderno.md5(PCuaderno.MiPCuaderno.entrada(PCuaderno.MiPCuaderno.mensajes.getString("Key"),
									PCuaderno.MiPCuaderno.mensajes.getString("Matricula_BtnImportarMateria_Entrada_Texto"),true));
						} else comprobada=true;
						if (acceso!=null) {
							if (!comprobada) {
								PCuaderno.MiPCuaderno.bbdd_temporal.conexionFijaCadenaCifrada(acceso);
								comprobada=PCuaderno.MiPCuaderno.bbdd_temporal.conexionDriverComprobar();
								}
							if (comprobada){
								acceso=null;
								PCuaderno.MiPCuaderno.bbdd_temporal.configuracionActualizar();
								//Hay materias a importar... -> seleccionar UNA
								Vector<Vector<String>> materiasImpor = PCuaderno.MiPCuaderno.bbdd_temporal.consultarMateria(null);
								Vector<Vector<String>> listaAElejir = new Vector<Vector<String>>(); 
								if (materiasImpor!=null) {
									for (int fila=0;fila<materiasImpor.size();fila++){
										Vector<String> elemento = new Vector<String>();
										elemento.add(materiasImpor.get(fila).get(0));
										elemento.add(materiasImpor.get(fila).get(6)+" "+materiasImpor.get(fila).get(5)+" "+
												materiasImpor.get(fila).get(4)+PCuaderno.MiPCuaderno.mensajes.getString("Ordinal")+
												" ("+materiasImpor.get(fila).get(1)+") "+
												materiasImpor.get(fila).get(2));
										listaAElejir.add(elemento);
									}
									ElegirDeUnList elegirDeUnListMateria = new ElegirDeUnList(PCuaderno.MiPCuaderno.shellPrincipal,
											PCuaderno.MiPCuaderno.mensajes.getString("Matricula_BtnImportarMateria_Elegir_Titulo"),
											PCuaderno.MiPCuaderno.mensajes.getString("Matricula_BtnImportarMateria_Elegir_Texto"),
											listaAElejir);
									String idMateria = elegirDeUnListMateria.open();
									elegirDeUnListMateria=null;
									if (idMateria!=null) {
										String idMateriaNueva=null;
										idMateriaNueva=BBDD.bbddImportarMateria(PCuaderno.MiPCuaderno.bbdd, PCuaderno.MiPCuaderno.bbdd_temporal, idMateria);
										if (idMateriaNueva!=null) {
											MateriaClase.fijarMateriaClaseParaMateria(idMateriaNueva,null);
											actualizar();
										}
									}
								} else {
									String me=PCuaderno.MiPCuaderno.mensajes.getString("Matricula_BtnImportarMateria_Inf_NoMaterias");
									PCuaderno.MiPCuaderno.informacion(me);
								}
							} else {
								acceso=null;
								m=PCuaderno.MiPCuaderno.mensajes.getString("Matricula_BtnImportarMateria_Info_NoConecto");
								PCuaderno.MiPCuaderno.informacion(m);
							}
							BBDD.bbddBorrarTemporal();
						}
		        	}
		        }
			}
		});
		
		btnImportarNoLectivos = new Button(compositeImportar, SWT.NONE);
		btnImportarNoLectivos.setLayoutData(new GridData(SWT.CENTER, SWT.CENTER, true, false, 1, 1));
		btnImportarNoLectivos.setText(PCuaderno.MiPCuaderno.mensajes.getString("Matricula_BtnImportarNoLectivos_Text"));
		btnImportarNoLectivos.setToolTipText(PCuaderno.MiPCuaderno.mensajes.getString("Matricula_BtnImportarNoLectivos_ToolTip"));
		btnImportarNoLectivos.addSelectionListener(new SelectionAdapter() {
			public void widgetSelected(SelectionEvent e) {
				if (PCuaderno.noti) PCuaderno.MiPCuaderno.notificar("btnImportarNoLectivos");
				String m=PCuaderno.MiPCuaderno.mensajes.getString("Matricula_BtnImportarNoLectivos_Preg_Copia");
				int buttonID = PCuaderno.MiPCuaderno.pregunta(m);
				if (buttonID != SWT.OK) {
					if (PCuaderno.MiPCuaderno.bbdd.bbddBackupHacer()) {
						m=PCuaderno.MiPCuaderno.mensajes.getString("Mantenimiento_BtnAlmacenHacer_Inf_Backup");
						PCuaderno.MiPCuaderno.informacion(m);
					} else {
						m=PCuaderno.MiPCuaderno.mensajes.getString("Mantenimiento_BtnAlmacenHacer_Err_Backup");
						PCuaderno.MiPCuaderno.error(m);
					}
				}
		        FileDialog fd = new FileDialog(PCuaderno.MiPCuaderno.shellPrincipal, SWT.OPEN);
		        fd.setText(PCuaderno.MiPCuaderno.mensajes.getString("Matricula_BtnImportarNoLectivos_Sel_Text"));
		        fd.setFilterPath(PCuaderno.MiPCuaderno.bbdd.dirBBDD+File.separatorChar);
		        String[] filterExt = { "*.zip","*.*" };
		        fd.setFilterExtensions(filterExt);
		        String nomArchivo = fd.open();
		        if (nomArchivo!=null) {
		        	if (!BBDD.bbddPreparaTemporal(nomArchivo)) {
						String me=PCuaderno.MiPCuaderno.mensajes.getString("Matricula_BtnImportarNoLectivos_Err_NoBackup");
						PCuaderno.MiPCuaderno.informacion(me);
		        	} else {
						String acceso="";
						boolean comprobada=false;
						PCuaderno.MiPCuaderno.bbdd_temporal.conexionFijaCadenaPlana();
						if (!PCuaderno.MiPCuaderno.bbdd_temporal.conexionComprobar()) {
							if (PCuaderno.noti) PCuaderno.MiPCuaderno.notificar("Asking password...");
							acceso=PCuaderno.MiPCuaderno.md5(PCuaderno.MiPCuaderno.entrada(PCuaderno.MiPCuaderno.mensajes.getString("Key"),
								PCuaderno.MiPCuaderno.mensajes.getString("Matricula_BtnImportarNoLectivos_Entrada_Texto"),true));
						} else comprobada=true;
						if (acceso!=null) {
							if (!comprobada) {
								PCuaderno.MiPCuaderno.bbdd_temporal.conexionFijaCadenaCifrada(acceso);
								comprobada=PCuaderno.MiPCuaderno.bbdd_temporal.conexionDriverComprobar();
								}
							if (comprobada){
								acceso=null;
								PCuaderno.MiPCuaderno.bbdd_temporal.configuracionActualizar();
								BBDD.bbddImportarNoLectivos(PCuaderno.MiPCuaderno.bbdd, PCuaderno.MiPCuaderno.bbdd_temporal);									
							} else {
								acceso=null;
								m=PCuaderno.MiPCuaderno.mensajes.getString("Matricula_BtnImportarNoLectivos_Info_NoConecto");
								PCuaderno.MiPCuaderno.informacion(m);
							}
							BBDD.bbddBorrarTemporal();
							Fecha.actualizarDiasNoLectivosClase();
							Fecha.actualizarDiasNoLectivosCompletos();
							actualizar();
							PCuaderno.MiPCuaderno.calendario.actualizarCalendario();
							PCuaderno.MiPCuaderno.mantenimiento.actualizar();
						}
		        	}
		        }
			}
		});
		
		btnImportarEventos = new Button(compositeImportar, SWT.NONE);
		btnImportarEventos.setLayoutData(new GridData(SWT.CENTER, SWT.CENTER, true, false, 1, 1));
		btnImportarEventos.setText(PCuaderno.MiPCuaderno.mensajes.getString("Matricula_BtnImportarEventos_Text"));
		btnImportarEventos.setToolTipText(PCuaderno.MiPCuaderno.mensajes.getString("Matricula_BtnImportarEventos_ToolTip"));
		btnImportarEventos.addSelectionListener(new SelectionAdapter() {
			public void widgetSelected(SelectionEvent e) {
				if (PCuaderno.noti) PCuaderno.MiPCuaderno.notificar("btnImportarEventos");
				String m=PCuaderno.MiPCuaderno.mensajes.getString("Matricula_BtnImportarEventos_Preg_Copia");
				int buttonID = PCuaderno.MiPCuaderno.pregunta(m);
				if (buttonID != SWT.OK) {
					if (PCuaderno.MiPCuaderno.bbdd.bbddBackupHacer()) {
						m=PCuaderno.MiPCuaderno.mensajes.getString("Mantenimiento_BtnAlmacenHacer_Inf_Backup");
						PCuaderno.MiPCuaderno.informacion(m);
					} else {
						m=PCuaderno.MiPCuaderno.mensajes.getString("Mantenimiento_BtnAlmacenHacer_Err_Backup");
						PCuaderno.MiPCuaderno.error(m);
					}
				}
		        FileDialog fd = new FileDialog(PCuaderno.MiPCuaderno.shellPrincipal, SWT.OPEN);
		        fd.setText(PCuaderno.MiPCuaderno.mensajes.getString("Matricula_BtnImportarEventos_Sel_Text"));
		        fd.setFilterPath(PCuaderno.MiPCuaderno.bbdd.dirBBDD+File.separatorChar);
		        String[] filterExt = { "*.zip","*.*" };
		        fd.setFilterExtensions(filterExt);
		        String nomArchivo = fd.open();
		        if (nomArchivo!=null) {
		        	if (!BBDD.bbddPreparaTemporal(nomArchivo)) {
						String me=PCuaderno.MiPCuaderno.mensajes.getString("Matricula_BtnImportarEventos_Err_NoBackup");
						PCuaderno.MiPCuaderno.informacion(me);
		        	} else {
						String acceso="";
						boolean comprobada=false;
						PCuaderno.MiPCuaderno.bbdd_temporal.conexionFijaCadenaPlana();
						if (!PCuaderno.MiPCuaderno.bbdd_temporal.conexionComprobar()) {
							if (PCuaderno.noti) PCuaderno.MiPCuaderno.notificar("Asking password...");
							acceso=PCuaderno.MiPCuaderno.md5(PCuaderno.MiPCuaderno.entrada(PCuaderno.MiPCuaderno.mensajes.getString("Key"),
								PCuaderno.MiPCuaderno.mensajes.getString("Matricula_BtnImportarEventos_Entrada_Texto"),true));
						} else comprobada=true;
						if (acceso!=null) {
							if (!comprobada) {
								PCuaderno.MiPCuaderno.bbdd_temporal.conexionFijaCadenaCifrada(acceso);
								comprobada=PCuaderno.MiPCuaderno.bbdd_temporal.conexionDriverComprobar();
								}
							if (comprobada){
								acceso=null;
								PCuaderno.MiPCuaderno.bbdd_temporal.configuracionActualizar();
								BBDD.bbddImportarEventos(PCuaderno.MiPCuaderno.bbdd, PCuaderno.MiPCuaderno.bbdd_temporal);
							} else {
								acceso=null;
								m=PCuaderno.MiPCuaderno.mensajes.getString("Matricula_BtnImportarEventos_Info_NoConecto");
								PCuaderno.MiPCuaderno.informacion(m);
							}
							BBDD.bbddBorrarTemporal();
							PCuaderno.MiPCuaderno.calendario.actualizarCalendario();
							PCuaderno.MiPCuaderno.evento.actualizar();
						}
		        	}
		        }
			}
		});
		
		Group grpTitulos = new Group(this, SWT.NONE);
		GridData gd_grpTitulos = new GridData(SWT.FILL, SWT.FILL, true, true, 1, 1);
		gd_grpTitulos.heightHint = 150;
		grpTitulos.setLayoutData(gd_grpTitulos);
		grpTitulos.setText(PCuaderno.MiPCuaderno.mensajes.getString("Matricula_GrpTitulos_Text"));
		GridLayout gl_grpTitulos = new GridLayout(2, false);
		gl_grpTitulos.verticalSpacing = 2;
		gl_grpTitulos.marginWidth = 2;
		gl_grpTitulos.marginHeight = 2;
		gl_grpTitulos.horizontalSpacing = 2;
		grpTitulos.setLayout(gl_grpTitulos);
		
		List listTitulos = new List(grpTitulos, SWT.BORDER | SWT.V_SCROLL);
		listTitulos.setToolTipText(PCuaderno.MiPCuaderno.mensajes.getString("Matricula_ListTitulos_ToolTip"));
		GridData gd_listTitulos = new GridData(SWT.FILL, SWT.FILL, true, true, 1, 3);
		gd_listTitulos.heightHint = 55;
		gd_listTitulos.widthHint = 60;
		listTitulos.setLayoutData(gd_listTitulos);
		listTitulos.addSelectionListener(new SelectionAdapter() {
			public void widgetSelected(SelectionEvent e) {
				if (PCuaderno.noti) PCuaderno.MiPCuaderno.notificar("listTitulos "+listConIdTitulos.idSeleccionado());
				actualizarDatosTitulo();
			}
		});
		listConIdTitulos = new ListConId(listTitulos);
		
		Label lblTituloRef = new Label(grpTitulos, SWT.NONE);
		lblTituloRef.setLayoutData(new GridData(SWT.RIGHT, SWT.CENTER, false, false, 1, 1));
		lblTituloRef.setText(PCuaderno.MiPCuaderno.mensajes.getString("Matricula_LblTituloRef_Text"));
		
		txtTituloRef = new Text(grpTitulos, SWT.BORDER);
		txtTituloRef.setToolTipText(PCuaderno.MiPCuaderno.mensajes.getString("Matricula_TxtTituloRef_ToolTip"));
		txtTituloRef.setText("XXXXX");
		GridData gd_textTituloRef = new GridData(SWT.FILL, SWT.CENTER, true, false, 1, 1);
		gd_textTituloRef.widthHint = 55;
		txtTituloRef.setLayoutData(gd_textTituloRef);
		TextoDemorado.add(txtTituloRef,false,5,null,null,false,listConIdTitulos,null);
		
		Composite compositeTituloNuevoBorrar = new Composite(grpTitulos, SWT.NONE);
		compositeTituloNuevoBorrar.setLayoutData(new GridData(SWT.LEFT, SWT.BOTTOM, false, false, 1, 1));
		GridLayout gl_compositeTituloNuevoBorrar = new GridLayout(1, false);
		gl_compositeTituloNuevoBorrar.verticalSpacing = 2;
		gl_compositeTituloNuevoBorrar.marginWidth = 2;
		gl_compositeTituloNuevoBorrar.marginHeight = 2;
		gl_compositeTituloNuevoBorrar.horizontalSpacing = 2;
		compositeTituloNuevoBorrar.setLayout(gl_compositeTituloNuevoBorrar);
		
		btnTituloNuevo = new Button(compositeTituloNuevoBorrar, SWT.NONE);
		btnTituloNuevo.setToolTipText(PCuaderno.MiPCuaderno.mensajes.getString("Matricula_BtnTituloNuevo_ToolTip"));
		btnTituloNuevo.addSelectionListener(new SelectionAdapter() {
			public void widgetSelected(SelectionEvent e) {
				if (PCuaderno.noti) PCuaderno.MiPCuaderno.notificar("btnTituloNuevo");
				String id = PCuaderno.MiPCuaderno.bbdd.insertarTitulo(listConIdEnsenanzas.idSeleccionado(),PCuaderno.MiPCuaderno.mensajes.getString("Matricula_BtnTituloNuevo_Nuevo"), "");
				actualizarTitulos(id);
				txtTituloRef.setFocus();
				txtTituloRef.selectAll();
			}
		});
		btnTituloNuevo.setText(PCuaderno.MiPCuaderno.mensajes.getString("Matricula_BtnTituloNuevo_Text"));
		
		btnTituloBorrar = new Button(compositeTituloNuevoBorrar, SWT.NONE);
		btnTituloBorrar.setToolTipText(PCuaderno.MiPCuaderno.mensajes.getString("Matricula_BtnTituloBorrar_ToolTip"));
		btnTituloBorrar.addSelectionListener(new SelectionAdapter() {
			public void widgetSelected(SelectionEvent e) {
				if (PCuaderno.noti) PCuaderno.MiPCuaderno.notificar("btnTituloBorrar");
					Vector<Vector<String>> niveles=PCuaderno.MiPCuaderno.bbdd.consultarNivel(listConIdTitulos.idSeleccionado(), null);
					if (niveles!=null) if (niveles.size()>0) {
						String m=PCuaderno.MiPCuaderno.mensajes.getString("Matricula_BtnTituloBorrar_Info_Nivel");
						PCuaderno.MiPCuaderno.informacion(m);
					} else {
						PCuaderno.MiPCuaderno.bbdd.borrarTitulo(listConIdTitulos.idSeleccionado());
						actualizarTitulos(null);
					}
				}
			});
		btnTituloBorrar.setText(PCuaderno.MiPCuaderno.mensajes.getString("Matricula_BtnTituloBorrar_Text"));
		
		txtTitulo = new Text(grpTitulos, SWT.BORDER);
		txtTitulo.setToolTipText(PCuaderno.MiPCuaderno.mensajes.getString("Matricula_TxtTitulo_ToolTip"));
		txtTitulo.setLayoutData(new GridData(SWT.FILL, SWT.CENTER, true, false, 2, 1));
		TextoDemorado.add(txtTitulo,false,1024,null,null,true,listConIdTitulos, null);
		
		grpEstudiantes = new Group(this, SWT.NONE);
		GridLayout gl_grpEstudiantes = new GridLayout(4, false);
		gl_grpEstudiantes.verticalSpacing = 2;
		gl_grpEstudiantes.marginWidth = 2;
		gl_grpEstudiantes.marginHeight = 2;
		gl_grpEstudiantes.horizontalSpacing = 2;
		grpEstudiantes.setLayout(gl_grpEstudiantes);
		GridData gd_grpEstudiantes = new GridData(SWT.FILL, SWT.FILL, true, true, 2, 1);
		gd_grpEstudiantes.minimumHeight = 155;
		gd_grpEstudiantes.heightHint = 150;
		grpEstudiantes.setLayoutData(gd_grpEstudiantes);
		grpEstudiantes.setText(TituloEstudiantes);
		
		List listEstudiantes = new List(grpEstudiantes, SWT.BORDER | SWT.V_SCROLL | SWT.MULTI);
		listEstudiantes.setToolTipText(PCuaderno.MiPCuaderno.mensajes.getString("Matricula_ListEstudiantes_ToolTip"));
		GridData gd_listEstudiantes = new GridData(SWT.FILL, SWT.FILL, true, true, 3, 1);
		gd_listEstudiantes.heightHint = 30;
		gd_listEstudiantes.widthHint = 150;
		listEstudiantes.setLayoutData(gd_listEstudiantes);
		listConIdEstudiantes = new ListConId(listEstudiantes);
		listEstudiantes.addSelectionListener(new SelectionAdapter() {
			public void widgetSelected(SelectionEvent e) {
				if (PCuaderno.noti) PCuaderno.MiPCuaderno.notificar("listEstudiantes "+((listConIdEstudiantes.idSeleccionados().size()>1)?"several":listConIdEstudiantes.idSeleccionado()));
				actualizarDatosEstudiante();
			}
		});
		
		Composite compositeEstudianteNuevoBorrar = new Composite(grpEstudiantes, SWT.NONE);
		compositeEstudianteNuevoBorrar.setLayoutData(new GridData(SWT.LEFT, SWT.TOP, false, true, 1, 1));
		GridLayout gl_compositeEstudianteNuevoBorrar = new GridLayout(1, false);
		gl_compositeEstudianteNuevoBorrar.verticalSpacing = 2;
		gl_compositeEstudianteNuevoBorrar.marginWidth = 2;
		gl_compositeEstudianteNuevoBorrar.marginHeight = 2;
		gl_compositeEstudianteNuevoBorrar.horizontalSpacing = 2;
		compositeEstudianteNuevoBorrar.setLayout(gl_compositeEstudianteNuevoBorrar);
		
		btnEstudianteNuevo = new Button(compositeEstudianteNuevoBorrar, SWT.NONE);
		btnEstudianteNuevo.setToolTipText(PCuaderno.MiPCuaderno.mensajes.getString("Matricula_BtnEstudianteNuevo_ToolTip"));
		btnEstudianteNuevo.setLayoutData(new GridData(SWT.FILL, SWT.FILL, false, false, 1, 1));
		btnEstudianteNuevo.addSelectionListener(new SelectionAdapter() {
			public void widgetSelected(SelectionEvent e) {
				if (PCuaderno.noti) PCuaderno.MiPCuaderno.notificar("btnEstudianteNuevo");
				String id = PCuaderno.MiPCuaderno.bbdd.insertarEstudiante(MateriaClase.getIdClaseDeTrabajo(),PCuaderno.MiPCuaderno.mensajes.getString("Matricula_BtnEstudianteNuevo_Nombre"),PCuaderno.MiPCuaderno.mensajes.getString("Matricula_BtnEstudianteNuevo_Apellidos"));
				listConIdEstudiantes.deSeleccionarTodo();
				actualizarEstudiantes(id);
				txtEstudianteNombre.setFocus();
				txtEstudianteNombre.selectAll();
			}
		});
		btnEstudianteNuevo.setText(PCuaderno.MiPCuaderno.mensajes.getString("Matricula_BtnEstudianteNuevo_Text"));
		
		btnEstudianteBorrar = new Button(compositeEstudianteNuevoBorrar, SWT.NONE);
		btnEstudianteBorrar.setToolTipText(PCuaderno.MiPCuaderno.mensajes.getString("Matricula_BtnEstudianteBorrar_ToolTip"));
		btnEstudianteBorrar.setLayoutData(new GridData(SWT.FILL, SWT.FILL, false, false, 1, 1));
		btnEstudianteBorrar.addSelectionListener(new SelectionAdapter() {
			public void widgetSelected(SelectionEvent e) {
				if (PCuaderno.noti) PCuaderno.MiPCuaderno.notificar("btnEstudianteBorrar "+listConIdEstudiantes.idSeleccionados().size()+" seleccionados.");
				String m=null;
				if (listConIdEstudiantes.idSeleccionados().size()>1){
					m=PCuaderno.MiPCuaderno.mensajes.getString("Matricula_BtnEstudianteBorrar_Preg_SeguroVarios1")+" "+listConIdEstudiantes.idSeleccionados().size()+" "+PCuaderno.MiPCuaderno.mensajes.getString("Matricula_BtnEstudianteBorrar_Preg_SeguroVarios2");
				} else {
					m=PCuaderno.MiPCuaderno.mensajes.getString("Matricula_BtnEstudianteBorrar_Preg_SeguroUno");
				}
				int buttonID = PCuaderno.MiPCuaderno.pregunta(m);
				if (buttonID == SWT.OK) {
					Vector<String> seleccionados = listConIdEstudiantes.idSeleccionados();
					for (int i=0;i<seleccionados.size();i++) 
						PCuaderno.MiPCuaderno.bbdd.borrarEstudiante(seleccionados.get(i));
					actualizarEstudiantes(null);
					actualizarMatriculados(null);
				}
			}
		});
		btnEstudianteBorrar.setText(PCuaderno.MiPCuaderno.mensajes.getString("Matricula_BtnEstudianteBorrar_Text"));
		
		btnEstudianteMatricular = new Button(compositeEstudianteNuevoBorrar, SWT.NONE);
		btnEstudianteMatricular.setToolTipText(PCuaderno.MiPCuaderno.mensajes.getString("Matricula_BtnEstudianteMatricular_ToolTip"));
		btnEstudianteMatricular.setLayoutData(new GridData(SWT.FILL, SWT.FILL, false, false, 1, 1));
		btnEstudianteMatricular.addSelectionListener(new SelectionAdapter() {
			public void widgetSelected(SelectionEvent e) {
				if (PCuaderno.noti) PCuaderno.MiPCuaderno.notificar("btnEstudianteMatricular");
				PCuaderno.MiPCuaderno.bbdd.insertarEstudiantesMateriaClase(MateriaClase.getIdMateriaClaseDeTrabajo(),
						listConIdEstudiantes.idSeleccionados());
				actualizarMatriculados(null);
			}
		});
		btnEstudianteMatricular.setText(PCuaderno.MiPCuaderno.mensajes.getString("Matricula_BtnEstudianteMatricular_Text"));
		
		txtEstudianteNombre = new Text(grpEstudiantes, SWT.BORDER);
		txtEstudianteNombre.setToolTipText(PCuaderno.MiPCuaderno.mensajes.getString("Matricula_TxtEstudianteNombre_ToolTip"));
		txtEstudianteNombre.setLayoutData(new GridData(SWT.FILL, SWT.CENTER, false, false, 1, 1));
		TextoDemorado.add(txtEstudianteNombre,false,256,null,null,false,listConIdEstudiantes,null);
		
		Label labelEstudianteComa = new Label(grpEstudiantes, SWT.NONE);
		labelEstudianteComa.setLayoutData(new GridData(SWT.RIGHT, SWT.CENTER, false, false, 1, 1));
		labelEstudianteComa.setText(",");
		
		txtEstudianteApellidos = new Text(grpEstudiantes, SWT.BORDER);
		txtEstudianteApellidos.setToolTipText(PCuaderno.MiPCuaderno.mensajes.getString("Matricula_TxtEstudianteApellidos_ToolTip"));
		txtEstudianteApellidos.setLayoutData(new GridData(SWT.FILL, SWT.CENTER, true, false, 2, 1));
		TextoDemorado.add(txtEstudianteApellidos,false,256,null,null,true,listConIdEstudiantes,null);
		
		composite = new Composite(grpEstudiantes, SWT.NONE);
		composite.setLayoutData(new GridData(SWT.FILL, SWT.FILL, false, false, 4, 1));
		GridLayout gl_composite = new GridLayout(2, false);
		gl_composite.verticalSpacing = 2;
		gl_composite.marginWidth = 2;
		gl_composite.marginHeight = 2;
		gl_composite.horizontalSpacing = 2;
		composite.setLayout(gl_composite);
		
		Label lblEstudianteDatos = new Label(composite, SWT.NONE);
		lblEstudianteDatos.setLayoutData(new GridData(SWT.RIGHT, SWT.CENTER, false, false, 1, 1));
		lblEstudianteDatos.setText(PCuaderno.MiPCuaderno.mensajes.getString("Matricula_LblEstudianteDatos_Text"));
		
		txtEstudianteDatos = new Text(composite, SWT.BORDER);
		txtEstudianteDatos.setLayoutData(new GridData(SWT.FILL, SWT.CENTER, true, false, 1, 1));
		txtEstudianteDatos.setToolTipText(PCuaderno.MiPCuaderno.mensajes.getString("Matricula_TxtEstudianteDatos_ToolTip"));
		TextoDemorado.add(txtEstudianteDatos,false,1024,null,null,true,listConIdEstudiantes,null);
		
		grpMatriculados = new Group(this, SWT.NONE);
		GridData gd_grpMatriculados = new GridData(SWT.FILL, SWT.FILL, true, true, 1, 1);
		gd_grpMatriculados.heightHint = 150;
		grpMatriculados.setLayoutData(gd_grpMatriculados);
		grpMatriculados.setText(TituloMatriculados);
		GridLayout gl_grpMatriculados = new GridLayout(1, false);
		gl_grpMatriculados.verticalSpacing = 2;
		gl_grpMatriculados.marginWidth = 2;
		gl_grpMatriculados.marginHeight = 2;
		gl_grpMatriculados.horizontalSpacing = 2;
		grpMatriculados.setLayout(gl_grpMatriculados);
		
		List listMatriculados = new List(grpMatriculados, SWT.BORDER | SWT.V_SCROLL | SWT.MULTI);
		listMatriculados.setToolTipText(PCuaderno.MiPCuaderno.mensajes.getString("Matricula_ListMatriculados_ToolTip"));
		GridData gd_listMatriculados = new GridData(SWT.FILL, SWT.FILL, true, true, 1, 1);
		gd_listMatriculados.heightHint = 55;
		listMatriculados.setLayoutData(gd_listMatriculados);
		listConIdMatriculados = new ListConId(listMatriculados);
		
		btnMatriculadoQuitar = new Button(grpMatriculados, SWT.NONE);
		btnMatriculadoQuitar.setToolTipText(PCuaderno.MiPCuaderno.mensajes.getString("Matricula_BtnMatriculadoQuitar_ToolTip"));
		btnMatriculadoQuitar.addSelectionListener(new SelectionAdapter() {
			public void widgetSelected(SelectionEvent e) {
				if (PCuaderno.noti) PCuaderno.MiPCuaderno.notificar("btnMatriculadoQuitar");
				PCuaderno.MiPCuaderno.bbdd.borrarEstudiantesMateriaClase(MateriaClase.getIdMateriaClaseDeTrabajo(),listConIdMatriculados.idSeleccionados());
				actualizarMatriculados(null);
			}
		});
		btnMatriculadoQuitar.setLayoutData(new GridData(SWT.FILL, SWT.CENTER, false, false, 1, 1));
		btnMatriculadoQuitar.setText(PCuaderno.MiPCuaderno.mensajes.getString("Matricula_BtnMatriculadoQuitar_Text"));
		new Label(this, SWT.NONE);
		new Label(this, SWT.NONE);
		new Label(this, SWT.NONE);
		new Label(this, SWT.NONE);
	}
	public void actualizarEnsenanzas(String idEnsenanza){
		listConIdEnsenanzas.rellenarEnsenanzas();
		listConIdEnsenanzas.seleccionarId((idEnsenanza!=null)?idEnsenanza:MateriaClase.getIdEnsenanzaDeTrabajo());
		actualizarDatosEnsenanza();
	}
	public void actualizarDatosEnsenanza(){
		if (listConIdEnsenanzas.idSeleccionado()==null){
			txtEnsenanzaRef.setEnabled(false);txtEnsenanzaRef.setText("");
			txtEnsenanza.setEnabled(false);txtEnsenanza.setText("");
			btnEnsenanzaBorrar.setEnabled(false);
		} else {
			Vector<Vector<String>> ensenanza=PCuaderno.MiPCuaderno.bbdd.consultarEnsenanza(listConIdEnsenanzas.idSeleccionado());
			TextoDemorado.modificaSinActualizar(txtEnsenanzaRef,ensenanza.get(0).get(1));
			TextoDemorado.modificaSinActualizar(txtEnsenanza,ensenanza.get(0).get(2));
			btnEnsenanzaBorrar.setEnabled(true);
		}
		actualizarTitulos(null);
	}
	public void actualizarTitulos(String idTitulo){
		listConIdTitulos.rellenarTitulos(listConIdEnsenanzas.idSeleccionado());
		listConIdTitulos.seleccionarId((idTitulo!=null)?idTitulo:MateriaClase.getIdTituloDeTrabajo());
		actualizarDatosTitulo();
	}
	public void actualizarDatosTitulo(){
		if (listConIdTitulos.idSeleccionado()==null){
			txtTituloRef.setEnabled(false);txtTituloRef.setText("");
			txtTitulo.setEnabled(false);txtTitulo.setText("");
			btnTituloBorrar.setEnabled(false);
		} else {
			Vector<Vector<String>> titulo=PCuaderno.MiPCuaderno.bbdd.consultarTitulo(listConIdEnsenanzas.idSeleccionado(),listConIdTitulos.idSeleccionado());
			TextoDemorado.modificaSinActualizar(txtTituloRef,titulo.get(0).get(2));
			TextoDemorado.modificaSinActualizar(txtTitulo,titulo.get(0).get(3));
			btnTituloBorrar.setEnabled(true);
		}
		if (listConIdEnsenanzas.idSeleccionado()==null) btnTituloNuevo.setEnabled(false);
		else btnTituloNuevo.setEnabled(true);
		actualizarNiveles(null);
	}
	public void actualizarNiveles(String idNivel){
		listConIdNiveles.rellenarNiveles(listConIdTitulos.idSeleccionado());
		listConIdNiveles.seleccionarId((idNivel!=null)?idNivel:MateriaClase.getIdNivelDeTrabajo());
		actualizarDatosNivel();
	}
	public void actualizarDatosNivel(){
		if (listConIdNiveles.idSeleccionado()==null){
			txtNivelRef.setEnabled(false);txtNivelRef.setText("");
			btnNivelBorrar.setEnabled(false);
		} else {
			Vector<Vector<String>> nivel=PCuaderno.MiPCuaderno.bbdd.consultarNivel(listConIdTitulos.idSeleccionado(),listConIdNiveles.idSeleccionado());
			TextoDemorado.modificaSinActualizar(txtNivelRef,nivel.get(0).get(2));
			btnNivelBorrar.setEnabled(true);
		}
		if (listConIdTitulos.idSeleccionado()==null) btnNivelNuevo.setEnabled(false);
		else btnNivelNuevo.setEnabled(true);
		actualizarClases(null);
		actualizarMaterias(null);
		MateriaClase.fijarMateriaClaseParaClase(listConIdMaterias.idSeleccionado(), listConIdClases.idSeleccionado());
		actualizarEstudiantes(null);
		actualizarMatriculados(null);
	}
	public void actualizarClases(String idClase){
		listConIdClases.rellenarClases(listConIdNiveles.idSeleccionado());
		listConIdClases.seleccionarId((idClase!=null)?idClase:MateriaClase.getIdClaseDeTrabajo());
		actualizarDatosClase();
	}
	public void actualizarDatosClase(){
		if (listConIdClases.idSeleccionado()==null){
			txtClaseRef.setEnabled(false);txtClaseRef.setText("");
			comboConIdClaseTutor.borrar();
			btnClaseBorrar.setEnabled(false);
		} else {
			Vector<Vector<String>> clase=PCuaderno.MiPCuaderno.bbdd.consultarClase(listConIdNiveles.idSeleccionado(),listConIdClases.idSeleccionado());
			TextoDemorado.modificaSinActualizar(txtClaseRef,clase.get(0).get(2));
			comboConIdClaseTutor.rellenarProfesores();
			comboConIdClaseTutor.seleccionarId(clase.get(0).get(5));
			btnClaseBorrar.setEnabled(true);
		}
		if (listConIdNiveles.idSeleccionado()==null) btnClaseNueva.setEnabled(false);
		else btnClaseNueva.setEnabled(true);
	}
	public void actualizarMaterias(String idMateria){
		listConIdMaterias.rellenarMaterias(listConIdNiveles.idSeleccionado());
		listConIdMaterias.seleccionarId((idMateria!=null)?idMateria:MateriaClase.getIdMateriaDeTrabajo());
		actualizarDatosMateria();
	}
	public void actualizarDatosMateria(){
		if (listConIdMaterias.idSeleccionado()==null){
			txtMateriaRef.setEnabled(false);txtMateriaRef.setText("");
			txtMateria.setEnabled(false);txtMateria.setText("");
			btnMateriaBorrar.setEnabled(false);
		} else {
			Vector<Vector<String>> clase=PCuaderno.MiPCuaderno.bbdd.consultarMateria(listConIdNiveles.idSeleccionado(),listConIdMaterias.idSeleccionado());
			TextoDemorado.modificaSinActualizar(txtMateriaRef,clase.get(0).get(1));
			TextoDemorado.modificaSinActualizar(txtMateria,clase.get(0).get(2));
			btnMateriaBorrar.setEnabled(true);
		}
		if (listConIdNiveles.idSeleccionado()==null) btnMateriaNueva.setEnabled(false);
		else btnMateriaNueva.setEnabled(true);
	}
	public void actualizarEstudiantes(String idEstudiante){
		listConIdEstudiantes.rellenarEstudiantes(listConIdClases.idSeleccionado());
		grpEstudiantes.setText(TituloEstudiantes+" "+listConIdEstudiantes.numeroElementos());
		listConIdEstudiantes.seleccionarId(idEstudiante);
		actualizarDatosEstudiante();
	}
	public void actualizarDatosEstudiante(){
		if (listConIdEstudiantes.idSeleccionado()==null){
			txtEstudianteNombre.setEnabled(false);txtEstudianteNombre.setText("");
			txtEstudianteApellidos.setEnabled(false);txtEstudianteApellidos.setText("");
			txtEstudianteDatos.setEnabled(false);txtEstudianteDatos.setText("");
			btnEstudianteBorrar.setEnabled(false);
			btnEstudianteMatricular.setEnabled(false);
		} else {
			if (listConIdEstudiantes.idSeleccionados().size()>1){
				txtEstudianteNombre.setEnabled(false);txtEstudianteNombre.setText("");
				txtEstudianteApellidos.setEnabled(false);txtEstudianteApellidos.setText("");
				txtEstudianteDatos.setEnabled(false);txtEstudianteDatos.setText("");
			} else {
				Vector<Vector<String>> clase=PCuaderno.MiPCuaderno.bbdd.consultarEstudiantesClase(listConIdClases.idSeleccionado(),listConIdEstudiantes.idSeleccionado());
				TextoDemorado.modificaSinActualizar(txtEstudianteNombre,clase.get(0).get(2));
				TextoDemorado.modificaSinActualizar(txtEstudianteApellidos,clase.get(0).get(1));
				TextoDemorado.modificaSinActualizar(txtEstudianteDatos,((clase.get(0).get(3)!=null)?clase.get(0).get(3):""));
			}
			btnEstudianteBorrar.setEnabled(true);
			if (listConIdMaterias.idSeleccionado()!=null)
				btnEstudianteMatricular.setEnabled(true);
			else
				btnEstudianteMatricular.setEnabled(false);
		}
		if (listConIdClases.idSeleccionado()==null) {
			btnEstudianteNuevo.setEnabled(false);
			btnImportarEstudiantes.setEnabled(false);
		} else {
			btnEstudianteNuevo.setEnabled(true);
			btnImportarEstudiantes.setEnabled(true);
		}
	}
	public void actualizarMatriculados(String idEstudiante){
		listConIdMatriculados.rellenarMatriculados(listConIdMaterias.idSeleccionado(),listConIdClases.idSeleccionado());
		grpMatriculados.setText(TituloMatriculados+" "+listConIdMatriculados.numeroElementos());
		listConIdMatriculados.seleccionarId(idEstudiante);
		actualizarDatosMatriculado();
	}
	public void actualizarDatosMatriculado(){
		if (listConIdMatriculados.numeroElementos()==0){
			btnMatriculadoQuitar.setEnabled(false);
		} else {
			btnMatriculadoQuitar.setEnabled(true);
		}
	}
}
