/** Copyright 2012
*
* Author: Ismael PONCE GORDILLO
*
* Licensed under the EUPL, Version 1.1 or – as soon they will be
* approved by the European Commission – subsequent versions of the
* EUPL (the "Licence"); you may not use this work except in
* compliance with the Licence.
* You may obtain a copy of the Licence at:
*
* https://joinup.ec.europa.eu/software/page/eupl/licence-eupl
*
* Unless required by applicable law or agreed to in writing,
* software distributed under the Licence is distributed on an "AS
* IS" BASIS, * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either
* express or implied.
* See the Licence for the specific language governing permissions
* and limitations under the Licence.
*/
import java.text.DecimalFormat;
import java.text.DecimalFormatSymbols;
import java.text.NumberFormat;
import java.text.ParseException;

public class Numero {

	private static final int decimales=1;
	public static final Double notaMax=10.0;
	public static String validarNumeroDecimal(String n,Double maximo,boolean vacio){
		String resultado=null;
		Double valor=null;
		if (n!=null) if (n.equals("")) {
			if (vacio) resultado=n;
		} else {
			DecimalFormat format=(DecimalFormat) DecimalFormat.getInstance();
			DecimalFormatSymbols symbols=format.getDecimalFormatSymbols();
			char sep=symbols.getDecimalSeparator();
			if (n.matches("[0-9][0-9]*(["+sep+"]"+"[0-9][0-9]*|)"))
			try {
				valor=Numero.numeroDecimal(n);
				//System.out.println("n "+n+" valor "+valor);
				if (maximo!=null) {
					if (valor!=null) if (valor<=maximo) resultado=Numero.cadena(valor);
				} else {
					if (valor!=null) resultado=Numero.cadena(valor);
				}
			} catch (NumberFormatException nfe) {
				//System.out.println("El valor ("+n+") no es un número valido.");
			}
		}
		if (PCuaderno.noti) PCuaderno.MiPCuaderno.notificar("("+n+","+maximo+","+vacio+") ["+valor+"]=> "+resultado);
		return resultado;
	}
	public static String validarNumeroEntero(String n, Double maximo,boolean vacio){
		String resultado=null;
		Integer valor=null;
		//System.out.println("validarNumeroEntero n["+n+"] !empty="+(!n.equals(""))+" PuedeSerVvacio="+vacio);
		if (n!=null) if (n.equals("")) {
			if (vacio) resultado=n;
		} else {
			if (n.matches("[0-9][0-9]*"))
			try {
				valor=Numero.numeroEntero(n);
				if (maximo!=null) {
					if (valor!=null) if (valor<=maximo) resultado=valor.toString();
				} else {
					if (valor!=null) resultado=valor.toString();
				}
			} catch (NumberFormatException nfe) {
				//System.out.println("El valor ("+n+") no es un número valido => "+resultado);
			}
		}
		if (PCuaderno.noti) PCuaderno.MiPCuaderno.notificar("("+n+","+maximo+","+vacio+") ["+valor+"]=> "+resultado);
		return resultado;
	}
	public static String cadena(Double d){
		NumberFormat nf = NumberFormat.getInstance();
		nf.setMaximumFractionDigits(Numero.decimales);
		return nf.format(d);
	}
	public static String cadenaEntero(Double d){
		NumberFormat nf = NumberFormat.getInstance();
		nf.setMaximumFractionDigits(0);
		return nf.format((d <= 0) ? Math.ceil(d) : Math.floor(d));
	}
	public static Double numeroDecimal(String c){
		Double resultado=null;
		NumberFormat nf = NumberFormat.getInstance();
		try { resultado=nf.parse(c).doubleValue();
		} catch (ParseException e) {
			//System.out.println("El valor ("+c+") no es un número valido => "+resultado);
		}
		return resultado;//Double.parseDouble(c.replace(".", "").replace(",", "."));
	}
	public static Integer numeroEntero(String c){
		if (PCuaderno.noti) PCuaderno.MiPCuaderno.notificar("("+c+")");
		Integer resultado=null;
		NumberFormat nf = NumberFormat.getInstance();
		try { resultado=nf.parse(c).intValue();
		} catch (ParseException e) {
			//System.out.println("El valor ("+c+") no es un número valido => "+resultado);
		}
		return resultado;//Integer.parseInt(c.replace(".", ""));
	}
	public static String cadenaDecimal(Double d){
		DecimalFormat dF = (DecimalFormat) NumberFormat.getInstance();
		dF.setMaximumFractionDigits(Numero.decimales);
		return dF.format(d);//(String.valueOf(d).replace(".", ","));
	}
	public static String cadenaEntero(Integer d){
		DecimalFormat dF = (DecimalFormat) NumberFormat.getInstance();
		dF.setMaximumFractionDigits(0);
		return dF.format(d);//(String.valueOf(d).replace(".", ","));
	}
}
