/** Copyright 2012
*
* Author: Ismael PONCE GORDILLO
*
* Licensed under the EUPL, Version 1.1 or – as soon they will be
* approved by the European Commission – subsequent versions of the
* EUPL (the "Licence"); you may not use this work except in
* compliance with the Licence.
* You may obtain a copy of the Licence at:
*
* https://joinup.ec.europa.eu/software/page/eupl/licence-eupl
*
* Unless required by applicable law or agreed to in writing,
* software distributed under the Licence is distributed on an "AS
* IS" BASIS, * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either
* express or implied.
* See the Licence for the specific language governing permissions
* and limitations under the Licence.
*/
import java.util.Calendar;
import java.util.Vector;

import org.eclipse.swt.widgets.Combo;

public class Parcial {
	private Calendar fPrimera;
	private Calendar fUltima;
	private Parcial (Calendar primera, Calendar ultima){
		this.fPrimera=primera;
		this.fUltima=ultima;
	}

	private static Vector<Parcial> parciales = new Vector<Parcial>();
	public static void inicializar(){
		if (PCuaderno.noti) PCuaderno.MiPCuaderno.notificar("Partial FechaDeTrabajo = "+Parcial.getParcial(Fecha.fechaDeTrabajo));
	}
	public static void defParciales(){
		if (PCuaderno.noti) PCuaderno.MiPCuaderno.notificar("()");
		Parcial.parciales.removeAllElements();
		Vector<Vector<String>> fechas = PCuaderno.MiPCuaderno.bbdd.consultarParcial(MateriaClase.getIdMateriaDeTrabajo(),null);
		if (fechas!=null)
			for (int i=0;i<fechas.size();i++){
				Calendar fi = Fecha.fechaHora(fechas.get(i).get(2),fechas.get(i).get(3),fechas.get(i).get(4),"0","0");
				Calendar ff = Fecha.fechaHora(fechas.get(i).get(5),fechas.get(i).get(6),fechas.get(i).get(7),"23","59");
				if (PCuaderno.noti) PCuaderno.MiPCuaderno.notificar("() "+i+": "+Fecha.formaFecha(fi)+" - "+Fecha.formaFecha(ff));
				Parcial p = new Parcial(fi,ff);
				Parcial.parciales.add(p);
			}
		if (PCuaderno.noti) PCuaderno.MiPCuaderno.notificar("() "+Parcial.parciales.size()+" partials.");
	}
	public static void setParcialDeTrabajo(Integer p){
		if (PCuaderno.noti) PCuaderno.MiPCuaderno.notificar("("+p+")");
		Calendar fechaActual=Fecha.getFechaHoraLaboralOSiguiente(Calendar.getInstance(), true);
		Integer parcialActual=getParcial(fechaActual);
		if (p.equals(parcialActual)) Fecha.fechaDeTrabajo=fechaActual;
		else Fecha.fechaDeTrabajo=Fecha.getFechaHoraLaboralOSiguiente(Parcial.getFechaInicioParcial(p), true);
		if (PCuaderno.noti) PCuaderno.MiPCuaderno.notificar("("+p+") => FechaTrabajo ("+Fecha.formaFechaDiaHora(Fecha.fechaDeTrabajo)+") fin");
	}
	public static void rellenarParciales(Combo comboParciales){
		if (PCuaderno.noti) PCuaderno.MiPCuaderno.notificar("(combo)");
		if (comboParciales!=null) {
			comboParciales.removeAll();
			for (int p=1;p<=parciales.size();p++){
				comboParciales.add(String.valueOf(p));
				if (p==Parcial.getParcial(Fecha.fechaDeTrabajo)) comboParciales.select(p-1);
			}
			if (comboParciales.getSelectionIndex()<0) comboParciales.select(0);
		}
		if (PCuaderno.noti) PCuaderno.MiPCuaderno.notificar("() "+comboParciales.getItemCount()+" elements");
	}
	public static int getParcial(Calendar f){
		int p=-1;
		if (Parcial.parciales.size()>0) {
			if (f.compareTo(Parcial.parciales.get(0).fPrimera)<0) {
				//System.out.println("Parcial getParcial error: fecha anterior al primer dia de curso p=1 ("+Fecha.formaFechaDia(f)+"<"+Fecha.formaFechaDia(Parcial.parciales.get(0).getfPrimera()));
				//p=-1;
				p=1;
			} else {
				p=0;
				do {
					p++;
					//System.out.println(" parcial "+p+", "+Fecha.formaFecha(Parcial.parciales.get(p-1).getfUltima()));
				} while (p<parciales.size() && f.compareTo(Parcial.parciales.get(p).fPrimera)>=0);
				//System.out.println("Parcial getParcial para "+Fecha.formaFechaDiaHora(f)+">"+Fecha.formaFechaDiaHora(Parcial.parciales.get(p).getfPrimera())+ " => "+p);
			}
		}
		if (PCuaderno.noti) PCuaderno.MiPCuaderno.notificar("("+Fecha.formaFechaDiaHora(f)+") "+p);
		return p; // el vector empieza en 0 pero yo trabajo empezando en 1 para primer parcial
	}
	public static int getParcialEstricto(Calendar f){
		int p=-1;
		if (Parcial.parciales.size()>0) {
			if (f.compareTo(Parcial.parciales.get(0).fPrimera)<0) {
				p=-1;
			} else {
				p=0;
				do {
					p++;
					//System.out.println(" parcial "+p+", "+Fecha.formaFecha(Parcial.parciales.get(p-1).getfUltima()));
				} while (p<parciales.size() && f.compareTo(Parcial.parciales.get(p).fPrimera)>=0);
				if (f.compareTo(Parcial.getFechaFinParcial(Parcial.numeroParciales()))>0) p=-1;
				//System.out.println("Parcial getParcial para "+Fecha.formaFechaDiaHora(f)+">"+Fecha.formaFechaDiaHora(Parcial.parciales.get(p).getfPrimera())+ " => "+p);
			}
		}
		if (PCuaderno.noti) PCuaderno.MiPCuaderno.notificar("("+Fecha.formaFechaDiaHora(f)+") "+p);
		return p; // el vector empieza en 0 pero yo trabajo empezando en 1 para primer parcial
	}
	/** 
	 * Get first date for parcial (1..n)
	 * @return new instance of Calendar with first date <br>
	 */
	public static Calendar getFechaInicioParcial(int p){
		Calendar f = null;
		if (p>0 && p<=parciales.size()) f=Parcial.parciales.get(p-1).fPrimera; 
		if (PCuaderno.noti) PCuaderno.MiPCuaderno.notificar("("+p+") "+Fecha.formaFechaDiaHora(f));
		return ((f!=null)?(Calendar)f.clone():null);
	}
	/** 
	 * Get last date for parcial (1..n)
	 * @return new instance of Calendar with last date <br>
	 */
	public static Calendar getFechaFinParcial(int p){
		Calendar f = null;
		if (p>0 && p<=parciales.size()) f=Parcial.parciales.get(p-1).fUltima;  
		if (PCuaderno.noti) PCuaderno.MiPCuaderno.notificar("("+p+") "+Fecha.formaFechaDiaHora(f));
		return ((f!=null)?(Calendar)f.clone():null);
	}
	public static int numeroDiasCurso(){return Parcial.getFechaFinParcial(Parcial.numeroParciales()).compareTo(Parcial.getFechaInicioParcial(1));}
	public static int numeroParciales(){return Parcial.parciales.size();}
	public static void imprimirParciales(){
		for (int i=1;i<=Parcial.parciales.size();i++)
			PCuaderno.MiPCuaderno.notificar("Partial "+i+": "+Fecha.formaFechaDia(Parcial.getFechaInicioParcial(i)) +
					" - "+Fecha.formaFechaDia(Parcial.getFechaFinParcial(i)));		
	}
}