/** Copyright 2012
*
* Author: Ismael PONCE GORDILLO
*
* Licensed under the EUPL, Version 1.1 or – as soon they will be
* approved by the European Commission – subsequent versions of the
* EUPL (the "Licence"); you may not use this work except in
* compliance with the Licence.
* You may obtain a copy of the Licence at:
*
* https://joinup.ec.europa.eu/software/page/eupl/licence-eupl
*
* Unless required by applicable law or agreed to in writing,
* software distributed under the Licence is distributed on an "AS
* IS" BASIS, * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either
* express or implied.
* See the Licence for the specific language governing permissions
* and limitations under the Licence.
*/
import java.util.Calendar;
import java.util.Vector;

import org.eclipse.swt.graphics.Color;
import org.eclipse.swt.graphics.Point;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Tree;
import org.eclipse.swt.SWT;
import org.eclipse.swt.widgets.Display;
import org.eclipse.swt.widgets.Label;
import org.eclipse.swt.widgets.Group;
import org.eclipse.swt.widgets.Button;
import org.eclipse.swt.widgets.List;
import org.eclipse.swt.widgets.Text;
import org.eclipse.swt.widgets.Combo;
import org.eclipse.swt.custom.TreeEditor;
import org.eclipse.swt.events.FocusAdapter;
import org.eclipse.swt.events.FocusEvent;
import org.eclipse.swt.events.KeyAdapter;
import org.eclipse.swt.events.KeyEvent;
import org.eclipse.swt.events.SelectionAdapter;
import org.eclipse.swt.events.SelectionEvent;
import org.eclipse.swt.widgets.TreeItem;

public class Programacion extends Composite {
	private Label labelMateria;
	private Combo comboMateria;
	private Tree treeIndice;
	private Button btnAdelantarNodo;
	private Button btnSubirNodo;
	private Button btnCrearNodoHijo;
	private Button btnBorrarNodo;
	private Button btnBajarNodo;
	private Button btnRetrasarNodo;
	private Text textSumario;public Text getTextSumario() {return textSumario;}
	private Text textDuracion;public Text getTextDuracion() {return textDuracion;}
	private Group grpSumario;
	private ComboConId comboConIdMateria;
	private Label lblClase;
	private Combo comboClase;
	private ComboConId comboConIdClase;
	private TreeConId treeConIdIndice;public TreeConId getTreeConIdIndice() {return treeConIdIndice;}
	private Group grpDistTemporal;
	private Group grpPorImpartir;
	private Group grpNodo;
	private Label lblDisponible;
	private Label lblTermina;
	private Label lblRequerido;
	private Button btnCrearHermano;
	private Button btnImportar;
	private Integer disponibleTotal=0;
	private Integer requeridoTotal=0;
	private Integer dispQueda=0;
	private List listEvaluables;
	private Label labelEvaluables;
	private Composite composite_Enunciado1;
	private Button buttonAhora;
	private Composite composite_Enunciado2;
	private Button buttonReajustar;
	private Label labelDuracion;
	private ListConId listConIdEvaluables;
	private Label lblTerminaParcialEtiqueta;
	private Label lblTerminaParcial;
	private Composite compositeFechaFin;
	private Composite compositeParcial;

	public Programacion(Composite parent, int style) {super(parent, style);initialize();}

	public void actualizar() {
		comboConIdMateria.rellenarMaterias(false);
		comboConIdMateria.seleccionarId(MateriaClase.getIdMateriaDeTrabajo());
		comboConIdClase.seleccionarId(MateriaClase.getIdClaseDeTrabajo());
		actualizarClases();
		treeConIdIndice.ponerArbol(null,MateriaClase.getIdMateriaDeTrabajo(),MateriaClase.getIdClaseDeTrabajo());
		actualizarDatosNodo();
		actualizarTiempos();
		btnImportar.setEnabled(comboConIdClase.idSeleccionado()!=null);
	}
	private void initialize() {
		GridLayout gridLayoutProgramacion = new GridLayout();
		gridLayoutProgramacion.numColumns = 2;
		gridLayoutProgramacion.horizontalSpacing = 2;
		gridLayoutProgramacion.verticalSpacing = 2;
		gridLayoutProgramacion.marginWidth = 2;
		gridLayoutProgramacion.marginHeight = 2;
		GridData gridDataProgramacion = new GridData();
		gridDataProgramacion.grabExcessHorizontalSpace = true;
		gridDataProgramacion.grabExcessVerticalSpace = true;
		gridDataProgramacion.horizontalAlignment = GridData.FILL;
		gridDataProgramacion.verticalAlignment = GridData.FILL;
		this.setLayoutData(gridDataProgramacion);
		this.setSize(new Point(685, 340));
		setLayout(gridLayoutProgramacion);

		creaCompositeMateriaGrupo();
		creaGrupoContenido();

		treeIndice = new Tree(this, SWT.BORDER);
		treeIndice.addSelectionListener(new SelectionAdapter() {
			public void widgetSelected(SelectionEvent e) {
				actualizarDatosNodo();
			}
		});
		GridData gd_treeIndice = new GridData(SWT.FILL, SWT.FILL, true, true,
				1, 1);
		gd_treeIndice.heightHint = 100;
		gd_treeIndice.widthHint = 200;
		treeIndice.setLayoutData(gd_treeIndice);
		treeIndice.setLinesVisible(true);
		treeConIdIndice = new TreeConId(treeIndice);
		treeIndice.setToolTipText(PCuaderno.MiPCuaderno.mensajes.getString("Programacion_TreeIndice_ToolTip"));
		final TreeEditor editor = new TreeEditor(treeIndice);
		editor.horizontalAlignment = SWT.LEFT;
		editor.grabHorizontal = true;
		treeIndice.addKeyListener(new KeyAdapter() {
			public void keyPressed(KeyEvent event) {
				if (event.keyCode == SWT.F2
						&& treeIndice.getSelectionCount() == 1) {
					final TreeItem nodoSeleccionado = treeIndice.getSelection()[0];
					final Text text = new Text(treeIndice, SWT.NONE);
					text.setText(nodoSeleccionado.getText());
					text.selectAll();
					text.setFocus();
					text.addFocusListener(new FocusAdapter() {
						public void focusLost(FocusEvent event) {
							nodoSeleccionado.setText(text.getText());
							PCuaderno.MiPCuaderno.bbdd.modificarProgramcionNodoEnunciado(
									treeConIdIndice.getId(nodoSeleccionado),
									text.getText());
							text.dispose();
						}
					});
					text.addKeyListener(new KeyAdapter() {
						public void keyPressed(KeyEvent event) {
							switch (event.keyCode) {
							case SWT.CR:
								PCuaderno.MiPCuaderno.bbdd.modificarProgramcionNodoEnunciado(
										treeConIdIndice.getId(nodoSeleccionado),
										text.getText());
								nodoSeleccionado.setText(text.getText());
							case SWT.ESC:
								text.dispose();
								treeIndice.setFocus();
								break;
							}
						}
					});
					editor.setEditor(text, nodoSeleccionado);
				}
			}
		});

		creaGrupoNodos();
		creaGrupoDuracion();

		grpSumario = new Group(this, SWT.NONE);
		grpSumario.setText(PCuaderno.MiPCuaderno.mensajes.getString("Programacion_GrpSumario_Text"));
		GridData gd_grpSumario = new GridData(SWT.FILL, SWT.FILL, true, true,
				2, 1);
		gd_grpSumario.heightHint = 80;
		grpSumario.setLayoutData(gd_grpSumario);
		grpSumario.setLayout(new GridLayout(2, false));

		textSumario = new Text(grpSumario, SWT.BORDER | SWT.MULTI | SWT.V_SCROLL);
		textSumario.setToolTipText(PCuaderno.MiPCuaderno.mensajes.getString("Programacion_TextSumario_ToolTip"));
		textSumario.setLayoutData(new GridData(SWT.FILL, SWT.FILL, true, true,
				2, 1));
		treeIndice.setFocus();
		TextoDemorado.add(textSumario,false,10240,null,null,true,treeConIdIndice,null);
		actualizarClases();
		actualizarTiempos();
	}

	private void creaCompositeMateriaGrupo() {
		Composite composite = new Composite(this, SWT.NONE);
		composite.setLayoutData(new GridData(SWT.FILL, SWT.FILL, false, false,1, 1));
		GridLayout gl_composite = new GridLayout(2, false);
		gl_composite.marginHeight = 0;
		gl_composite.marginWidth = 0;
		composite.setLayout(gl_composite);
		labelMateria = new Label(composite, SWT.NONE);
		labelMateria.setLayoutData(new GridData(SWT.RIGHT, SWT.CENTER, false,false, 1, 1));
		labelMateria.setText(PCuaderno.MiPCuaderno.mensajes.getString("Programacion_LabelMateria_Text"));
		comboMateria = new Combo(composite, SWT.READ_ONLY);
		comboMateria.setToolTipText(PCuaderno.MiPCuaderno.mensajes.getString("Programacion_ComboMateria_ToolTip"));
		comboMateria.addSelectionListener(new SelectionAdapter() {
			public void widgetSelected(SelectionEvent e) {
				comboConIdClase.rellenarClases(comboConIdMateria.idSeleccionado(),null,null);
				MateriaClase.fijarMateriaClaseParaMateria(
						comboConIdMateria.idSeleccionado(),
						comboConIdClase.idSeleccionado());
				actualizarClases();
				treeConIdIndice.ponerArbol(null,MateriaClase.getIdMateriaDeTrabajo(),MateriaClase.getIdClaseDeTrabajo());
				actualizarDatosNodo();
				actualizarTiempos();
			}
		});
		GridData gd_comboMateria = new GridData(SWT.FILL, SWT.FILL, true,false, 1, 1);
		gd_comboMateria.widthHint = 200;
		comboMateria.setLayoutData(gd_comboMateria);
		comboConIdMateria = new ComboConId(comboMateria);
	}

	private void creaGrupoContenido() {
		Group grpGestorNodos = new Group(this, SWT.NONE);
		grpGestorNodos.setText(PCuaderno.MiPCuaderno.mensajes.getString("Programacion_GrpGestorNodos_Text"));
		GridData gd_grpGestorNodos = new GridData(SWT.FILL, SWT.FILL, false,false, 1, 3);
		gd_grpGestorNodos.heightHint = 200;
		grpGestorNodos.setLayoutData(gd_grpGestorNodos);
		grpGestorNodos.setLayout(new GridLayout(1, false));
		btnAdelantarNodo = new Button(grpGestorNodos, SWT.NONE);
		btnAdelantarNodo.setToolTipText(PCuaderno.MiPCuaderno.mensajes.getString("Programacion_BtnAdelantarNodo_ToolTip"));
		btnAdelantarNodo.setLayoutData(new GridData(SWT.FILL, SWT.FILL, false,true, 1, 1));
		btnAdelantarNodo.addSelectionListener(new SelectionAdapter() {
			public void widgetSelected(SelectionEvent e) {
				TreeItem nodoSeleccionado = treeConIdIndice.selecionado();
				TreeItem nodoHermanoAnterior = treeConIdIndice
						.getHermanoAnterior(nodoSeleccionado);
				if (nodoSeleccionado != null && nodoHermanoAnterior != null) {
					PCuaderno.MiPCuaderno.bbdd.modificarProgramcionNodoIntercambiaPos(
							treeConIdIndice.getIdSeleccionado(),
							treeConIdIndice.getId(nodoHermanoAnterior));
					if (PCuaderno.noti) PCuaderno.MiPCuaderno.notificar("btnAdelantarNodo idNodoSeleccionado="
									+ treeConIdIndice.getIdSeleccionado()
									+ ", node=" + nodoSeleccionado.handle);
					treeConIdIndice.ponerArbol(null,MateriaClase.getIdMateriaDeTrabajo(),MateriaClase.getIdClaseDeTrabajo());
					actualizarDatosNodo();
				}
				treeIndice.setFocus();
			}
		});
		btnAdelantarNodo.setText(PCuaderno.MiPCuaderno.mensajes.getString("Programacion_BtnAdelantarNodo_Text"));
		btnSubirNodo = new Button(grpGestorNodos, SWT.NONE);
		btnSubirNodo.setToolTipText(PCuaderno.MiPCuaderno.mensajes.getString("Programacion_BtnSubirNodo_ToolTip"));
		btnSubirNodo.setLayoutData(new GridData(SWT.FILL, SWT.FILL, false,true, 1, 1));
		btnSubirNodo.addSelectionListener(new SelectionAdapter() {
			public void widgetSelected(SelectionEvent e) {
				// si el es último de los hermanos sube detras del padre
				// si no sube delante del padre
				TreeItem nodoSeleccionado = treeConIdIndice.selecionado();
				TreeItem nodoPadre = treeConIdIndice.getPadre(nodoSeleccionado);
				if (nodoPadre != null) {
					TreeItem nodoHermanoPosterior = treeConIdIndice
							.getHermanoPosterior(nodoSeleccionado);
					String idNodoSeleccionado = treeConIdIndice
							.getIdSeleccionado();
					String idPadre = treeConIdIndice.getId(nodoPadre);
					PCuaderno.MiPCuaderno.bbdd.modificarProgramcionNodoSubirNodo(idNodoSeleccionado);
					if (nodoHermanoPosterior == null)
						PCuaderno.MiPCuaderno.bbdd.modificarProgramcionNodoIntercambiaPos(
								idNodoSeleccionado, idPadre);
					if (PCuaderno.noti) PCuaderno.MiPCuaderno.notificar("btnSubirNodo idNodoSeleccionado="
									+ idNodoSeleccionado
									+ ", node="
									+ treeConIdIndice
											.getNodo(idNodoSeleccionado));
					treeConIdIndice.ponerArbol(null,MateriaClase.getIdMateriaDeTrabajo(),MateriaClase.getIdClaseDeTrabajo());
					actualizarDatosNodo();
				}
				treeIndice.setFocus();
			}
		});
		btnSubirNodo.setText(PCuaderno.MiPCuaderno.mensajes.getString("Programacion_BtnSubirNodo_Text"));
		btnCrearNodoHijo = new Button(grpGestorNodos, SWT.NONE);
		btnCrearNodoHijo.setToolTipText(PCuaderno.MiPCuaderno.mensajes.getString("Programacion_BtnCrearNodoHijo_ToolTip"));
		btnCrearNodoHijo.setLayoutData(new GridData(SWT.FILL, SWT.FILL, false,true, 1, 1));
		btnCrearNodoHijo.addSelectionListener(new SelectionAdapter() {
			public void widgetSelected(SelectionEvent e) {
				if (PCuaderno.noti) PCuaderno.MiPCuaderno.notificar("Creando Nodo Hijo");
				if (comboConIdMateria.numeroElementos().equals(0)) {
					PCuaderno.MiPCuaderno.error(PCuaderno.MiPCuaderno.mensajes.getString("Programacion_BtnCrearNodoHijo_Err_NoMateria"));
				} else if (comboConIdMateria.idSeleccionado()==null) {
					PCuaderno.MiPCuaderno.error(PCuaderno.MiPCuaderno.mensajes.getString("Programacion_BtnCrearNodoHijo_Err_NoSelMateria"));
				} else {
					TreeItem nodoSeleccionado = treeConIdIndice.selecionado();
					String idSeleccionado = treeConIdIndice.getIdSeleccionado();
					boolean nodoNuevo = false;
					Integer duracion = 0;
					if (nodoSeleccionado != null) {
						Vector<Vector<String>> temporal = PCuaderno.MiPCuaderno.bbdd
								.consultarProgramacionDuracionNodo(idSeleccionado,
										MateriaClase.getIdClaseDeTrabajo());
						if (temporal != null)
							if (temporal.size() > 0)
								duracion = Integer.valueOf(temporal.get(0).get(2));
						nodoNuevo = true;
						Integer orden = nodoSeleccionado.getItemCount() + 1;
						String idNodo = PCuaderno.MiPCuaderno.bbdd.insertarProgramacionNodo(PCuaderno.MiPCuaderno.mensajes.getString("Programacion_BtnCrearNodo_Nuevo"),
								treeConIdIndice.getId(nodoSeleccionado), orden,
								comboConIdMateria.idSeleccionado());
						PCuaderno.MiPCuaderno.bbdd.borrarProgramacionDuracionNodo(idSeleccionado,
								MateriaClase.getIdClaseDeTrabajo());
						if (duracion > 0)
							PCuaderno.MiPCuaderno.bbdd.insertarProgramacionDuracionNodo(idNodo,
									MateriaClase.getIdClaseDeTrabajo(), duracion);
						if (PCuaderno.noti) PCuaderno.MiPCuaderno.notificar("btnCrearNodoHijo " + orden
								+ ": (" + idNodo + ") New");
					} else {
						if (treeConIdIndice.getPrimero() == null) {
							nodoNuevo = true;
							String idNodo = PCuaderno.MiPCuaderno.bbdd.insertarProgramacionNodo(PCuaderno.MiPCuaderno.mensajes.getString("Programacion_BtnCrearNodo_Nuevo"),
									"NULL", 1, comboConIdMateria.idSeleccionado());
							if (PCuaderno.noti) PCuaderno.MiPCuaderno.notificar("btnCrearNodoHijo first and only: ("
											+ idNodo + ") New");
						}
					}
					if (nodoNuevo) {
						treeConIdIndice.ponerArbol(null,MateriaClase.getIdMateriaDeTrabajo(),MateriaClase.getIdClaseDeTrabajo());
						actualizarDatosNodo();
					}
					treeIndice.setFocus();
				}
			}
		});
		btnCrearNodoHijo.setText(PCuaderno.MiPCuaderno.mensajes.getString("Programacion_BtnCrearNodoHijo_Text"));
		btnCrearHermano = new Button(grpGestorNodos, SWT.NONE);
		btnCrearHermano.setToolTipText(PCuaderno.MiPCuaderno.mensajes.getString("Programacion_BtnCrearHermano_ToolTip"));
		btnCrearHermano.setLayoutData(new GridData(SWT.FILL, SWT.FILL, false, true, 1, 1));
		btnCrearHermano.addSelectionListener(new SelectionAdapter() {
			public void widgetSelected(SelectionEvent e) {
				TreeItem nodoSeleccionado = treeConIdIndice.selecionado();
				if (nodoSeleccionado != null) {
					String idNodo = PCuaderno.MiPCuaderno.bbdd.insertarProgramacionNodoHermano(treeConIdIndice.getIdSeleccionado());
					treeConIdIndice.ponerArbol(idNodo,MateriaClase.getIdMateriaDeTrabajo(),MateriaClase.getIdClaseDeTrabajo());
					//treeConIdIndice.expandir(idNodo);
					actualizarDatosNodo();
				}
				treeIndice.setFocus();
			}
		});
		btnCrearHermano.setText(PCuaderno.MiPCuaderno.mensajes.getString("Programacion_BtnCrearHermano_Text"));
		btnBorrarNodo = new Button(grpGestorNodos, SWT.NONE);
		btnBorrarNodo.setToolTipText(PCuaderno.MiPCuaderno.mensajes.getString("Programacion_BtnBorrarNodo_ToolTip"));
		btnBorrarNodo.setLayoutData(new GridData(SWT.FILL, SWT.FILL, false,true, 1, 1));
		btnBorrarNodo.addSelectionListener(new SelectionAdapter() {
			public void widgetSelected(SelectionEvent e) {
				if (PCuaderno.noti) PCuaderno.MiPCuaderno.notificar("btnBorrarNodo");
				int buttonID = SWT.OK;
				if (treeConIdIndice.seleccionadoTieneHijos()) {
					String m=PCuaderno.MiPCuaderno.mensajes.getString("Programacion_BtnBorrarNodo_Preg_Seguro");
					buttonID = PCuaderno.MiPCuaderno.pregunta(m);
				}
				if (buttonID == SWT.OK) {
					TreeItem nodoSeleccionado = treeConIdIndice.selecionado();
					TreeItem padre = treeConIdIndice.getPadre(nodoSeleccionado);
					TreeItem hermanoAnterior = treeConIdIndice.getHermanoAnterior(nodoSeleccionado);
					TreeItem hermanoPosterior = treeConIdIndice.getHermanoPosterior(nodoSeleccionado);
					PCuaderno.MiPCuaderno.bbdd.borrarProgramacionNodoReOrdena(treeConIdIndice.getId(nodoSeleccionado));
					if (padre != null) {
						treeConIdIndice.seleccionar(padre);
					} else {
						if (hermanoAnterior != null) {
							treeConIdIndice.seleccionar(hermanoAnterior);
						} else {
							if (hermanoPosterior != null) {
								treeConIdIndice.seleccionar(hermanoPosterior);
							}
						}
					}
					treeConIdIndice.ponerArbol(null,MateriaClase.getIdMateriaDeTrabajo(),MateriaClase.getIdClaseDeTrabajo());
					actualizarRequeridoTotal();
					actualizarDatosNodo();
				}
				treeIndice.setFocus();
			}
		});
		btnBorrarNodo.setText(PCuaderno.MiPCuaderno.mensajes.getString("Programacion_BtnBorrarNodo_Text"));
		btnBajarNodo = new Button(grpGestorNodos, SWT.NONE);
		btnBajarNodo.setToolTipText(PCuaderno.MiPCuaderno.mensajes.getString("Programacion_BtnBajarNodo_ToolTip"));
		btnBajarNodo.setLayoutData(new GridData(SWT.FILL, SWT.FILL, false,true, 1, 1));
		btnBajarNodo.addSelectionListener(new SelectionAdapter() {
			public void widgetSelected(SelectionEvent e) {
				// si el es primero de los hermanos baja el primero del hermano
		// posterior
		// si no baja el último del hermano anterior
				TreeItem nodoSeleccionado = treeConIdIndice.selecionado();
				TreeItem nodoHermanoPosterior = treeConIdIndice
						.getHermanoPosterior(nodoSeleccionado);
				TreeItem nodoHermanoAnterior = treeConIdIndice
						.getHermanoAnterior(nodoSeleccionado);
				if (nodoHermanoPosterior != null || nodoHermanoAnterior != null) {
					String idNodo = treeConIdIndice.getId(nodoSeleccionado);
					if (nodoHermanoAnterior == null) {
						String idPosterior = treeConIdIndice
								.getId(nodoHermanoPosterior);
						PCuaderno.MiPCuaderno.bbdd.modificarProgramcionNodoBajarNodo(idNodo,
								idPosterior, true);
					} else {
						String idAnterior = treeConIdIndice
								.getId(nodoHermanoAnterior);
						PCuaderno.MiPCuaderno.bbdd.modificarProgramcionNodoBajarNodo(idNodo,
								idAnterior, false);
					}
					treeConIdIndice.ponerArbol(null,MateriaClase.getIdMateriaDeTrabajo(),MateriaClase.getIdClaseDeTrabajo());
					actualizarDatosNodo();
				}
				treeIndice.setFocus();
			}
		});
		btnBajarNodo.setText(PCuaderno.MiPCuaderno.mensajes.getString("Programacion_BtnBajarNodo_Text"));
		btnRetrasarNodo = new Button(grpGestorNodos, SWT.NONE);
		btnRetrasarNodo.setToolTipText(PCuaderno.MiPCuaderno.mensajes.getString("Programacion_BtnRetrasarNodo_ToolTip"));
		btnRetrasarNodo.setLayoutData(new GridData(SWT.FILL, SWT.FILL, false,true, 1, 1));
		btnRetrasarNodo.addSelectionListener(new SelectionAdapter() {
			public void widgetSelected(SelectionEvent e) {
				TreeItem nodoSeleccionado = treeConIdIndice.selecionado();
				TreeItem nodoHermanoPosterior = treeConIdIndice
						.getHermanoPosterior(nodoSeleccionado);
				if (nodoSeleccionado != null && nodoHermanoPosterior != null) {
					PCuaderno.MiPCuaderno.bbdd.modificarProgramcionNodoIntercambiaPos(
							treeConIdIndice.getIdSeleccionado(),
							treeConIdIndice.getId(nodoHermanoPosterior));
					if (PCuaderno.noti) PCuaderno.MiPCuaderno.notificar("btnRetrasarNodo idNodoSeleccionado="
									+ treeConIdIndice.getIdSeleccionado()
									+ ", node=" + nodoSeleccionado.handle);
					treeConIdIndice.ponerArbol(null,MateriaClase.getIdMateriaDeTrabajo(),MateriaClase.getIdClaseDeTrabajo());
					actualizarDatosNodo();
				}
				treeIndice.setFocus();
			}
		});
		btnRetrasarNodo.setText(PCuaderno.MiPCuaderno.mensajes.getString("Programacion_BtnRetrasarNodo_Text"));
		btnImportar = new Button(grpGestorNodos, SWT.NONE);
		btnImportar.setLayoutData(new GridData(SWT.FILL, SWT.FILL, false, true, 1, 1));
		btnImportar.addSelectionListener(new SelectionAdapter() {
			public void widgetSelected(SelectionEvent e) {
				if (PCuaderno.noti) PCuaderno.MiPCuaderno.notificar("btnImportar");
				String m=PCuaderno.MiPCuaderno.mensajes.getString("Programacion_BtnImportar_Preg_Seguro");
				int buttonID = PCuaderno.MiPCuaderno.pregunta(m);
				if (buttonID == SWT.OK) PCuaderno.MiPCuaderno.bbdd.importarProgramacion(MateriaClase.getIdMateriaDeTrabajo());
				treeConIdIndice.ponerArbol(null,MateriaClase.getIdMateriaDeTrabajo(),MateriaClase.getIdClaseDeTrabajo());
				actualizarDatosNodo();
			}
		});
		btnImportar.setText(PCuaderno.MiPCuaderno.mensajes.getString("Programacion_BtnImportar_Text"));
		btnImportar.setToolTipText(PCuaderno.MiPCuaderno.mensajes.getString("Programacion_BtnImportar_ToolTip"));
	}

	private void creaGrupoNodos() {
	}

	private void creaGrupoDuracion() {
		grpDistTemporal = new Group(this, SWT.NONE);
		grpDistTemporal.setText(PCuaderno.MiPCuaderno.mensajes.getString("Programacion_GrpDistTemporal_Text"));
		grpDistTemporal.setLayoutData(new GridData(SWT.FILL, SWT.FILL, false,false, 1, 1));
		GridLayout gl_grpDistTemporal = new GridLayout(6, false);
		gl_grpDistTemporal.verticalSpacing = 2;
		gl_grpDistTemporal.marginWidth = 2;
		gl_grpDistTemporal.marginHeight = 2;
		gl_grpDistTemporal.horizontalSpacing = 2;
		grpDistTemporal.setLayout(gl_grpDistTemporal);
		lblClase = new Label(grpDistTemporal, SWT.NONE);
		lblClase.setLayoutData(new GridData(SWT.RIGHT, SWT.CENTER, false,false, 1, 1));
		lblClase.setText(PCuaderno.MiPCuaderno.mensajes.getString("Programacion_LblClase_Text"));
		comboClase = new Combo(grpDistTemporal, SWT.READ_ONLY);
		comboClase.setToolTipText(PCuaderno.MiPCuaderno.mensajes.getString("Programacion_ComboClase_ToolTip"));
		comboClase.addSelectionListener(new SelectionAdapter() {
			public void widgetSelected(SelectionEvent e) {
				MateriaClase.fijarMateriaClaseParaClase(
						comboConIdMateria.idSeleccionado(),
						comboConIdClase.idSeleccionado());
				if (PCuaderno.noti) PCuaderno.MiPCuaderno.notificar("comboClase materiaclase ["+MateriaClase.getIdMateriaClaseDeTrabajo()+"]",false);
				disponibleTotal = MateriaClase.minutosDisponiblesEnMateriaClaseTrabajoDesdeFecha(null);
				treeConIdIndice.actualizarMinutosNodosParaClaseTrabajo(null);
				actualizarTiempos();
				if (treeConIdIndice.getPrimero()!=null)
					treeConIdIndice.seleccionar(treeConIdIndice.nodoParaMinutosRequeridos(MateriaClase.minutosHastaFechaEnMateriaClaseTrabajo(Fecha.fechaDeTrabajo)));
				actualizarDatosNodo();
				if (PCuaderno.noti) PCuaderno.MiPCuaderno.notificar("comboClase materiaclase ["+MateriaClase.getIdMateriaClaseDeTrabajo()+"]",true);
			}
		});
		GridData gd_comboClase = new GridData(SWT.FILL, SWT.CENTER, true,false, 1, 1);
		gd_comboClase.widthHint = 60;
		comboClase.setLayoutData(gd_comboClase);
		comboConIdClase = new ComboConId(comboClase);
		grpNodo = new Group(grpDistTemporal, SWT.NONE);
		GridLayout gl_grpNodo = new GridLayout(1, false);
		gl_grpNodo.verticalSpacing = 2;
		gl_grpNodo.marginWidth = 2;
		gl_grpNodo.marginHeight = 2;
		gl_grpNodo.horizontalSpacing = 2;
		grpNodo.setLayout(gl_grpNodo);
		GridData gd_grpNodo = new GridData(SWT.FILL, SWT.CENTER, true, false, 3, 2);
		gd_grpNodo.minimumWidth = 160;
		gd_grpNodo.widthHint = 160;
		grpNodo.setLayoutData(gd_grpNodo);
		grpNodo.setText(PCuaderno.MiPCuaderno.mensajes.getString("Programacion_GrpNodo_Text"));
		composite_Enunciado1 = new Composite(grpNodo, SWT.NONE);
		composite_Enunciado1.setLayoutData(new GridData(SWT.FILL, SWT.FILL, true, false, 1, 1));
		GridLayout gl_composite_Enunciado1 = new GridLayout(3, false);
		gl_composite_Enunciado1.verticalSpacing = 2;
		gl_composite_Enunciado1.marginWidth = 2;
		gl_composite_Enunciado1.horizontalSpacing = 2;
		gl_composite_Enunciado1.marginHeight = 2;
		composite_Enunciado1.setLayout(gl_composite_Enunciado1);
		labelDuracion = new Label(composite_Enunciado1, SWT.NONE);
		labelDuracion.setLayoutData(new GridData(SWT.RIGHT, SWT.CENTER, false, false, 1, 1));
		labelDuracion.setText(PCuaderno.MiPCuaderno.mensajes.getString("Programacion_LblDuracion_Text"));
		textDuracion = new Text(composite_Enunciado1, SWT.BORDER);
		GridData gd_textDuracion = new GridData(SWT.FILL, SWT.CENTER, true, false, 1, 1);
		gd_textDuracion.minimumWidth = 50;
		gd_textDuracion.widthHint = 50;
		textDuracion.setLayoutData(gd_textDuracion);
		textDuracion.setToolTipText(PCuaderno.MiPCuaderno.mensajes.getString("Programacion_TextDuracion_ToolTip"));
		TextoDemorado.add(textDuracion,true,5,null,null,false,treeConIdIndice,comboConIdClase);
		buttonAhora = new Button(composite_Enunciado1, SWT.NONE);
		buttonAhora.setLayoutData(new GridData(SWT.RIGHT, SWT.CENTER, true, false, 1, 1));
		buttonAhora.setText(PCuaderno.MiPCuaderno.mensajes.getString("Programacion_btnEnunciadoAhora_Text"));
		buttonAhora.setToolTipText(PCuaderno.MiPCuaderno.mensajes.getString("Programacion_btnEnunciadoAhora_ToolTip"));
		buttonAhora.addSelectionListener(new SelectionAdapter() {
			public void widgetSelected(SelectionEvent e) {
				if (PCuaderno.noti) PCuaderno.MiPCuaderno.notificar("btnAhora");
				if (PCuaderno.MiPCuaderno.bbdd.consultarUHvacio(MateriaClase.getIdMateriaClaseDeTrabajo())) {
					PCuaderno.MiPCuaderno.error(PCuaderno.MiPCuaderno.mensajes.getString("Programacion_ButtonAhora_Error_NoSchedule"));
				} else if (Parcial.numeroParciales()<=0) {
					PCuaderno.MiPCuaderno.error(PCuaderno.MiPCuaderno.mensajes.getString("Programacion_ButtonAhora_Error_NoPartial"));
				} else {
					Integer tiempo = treeConIdIndice.minutosRequeridosPorNodoParaAcabarAhoraEnDisponible(treeConIdIndice.selecionado());
					if (tiempo>=0) {
						String duracion = tiempo.toString();
						//System.out.println("duracion = "+tiempo+"=>"+duracion);
						PCuaderno.MiPCuaderno.bbdd.modificarProgramcionNodoDuracion(MateriaClase.getIdClaseDeTrabajo(),treeConIdIndice.getIdSeleccionado(), duracion);
						treeConIdIndice.fijarMinutosRequeridos(treeConIdIndice.selecionado(), tiempo);
						//System.out.println("ahora: "+MateriaClase.getIdClaseDeTrabajo()+", "+treeConIdIndice.getIdSeleccionado()+", "+duracion);
						actualizarDatosNodo();
						actualizarRequeridoTotal();
					} else {
						String m=PCuaderno.MiPCuaderno.mensajes.getString("Programacion_BtnAhora_Aviso_Imposible");
						PCuaderno.MiPCuaderno.aviso(m);
					}
				}
			}
		});
		composite_Enunciado2 = new Composite(grpNodo, SWT.NONE);
		composite_Enunciado2.setLayoutData(new GridData(SWT.FILL, SWT.FILL, true, false, 1, 1));
		GridLayout gl_composite_Enunciado2 = new GridLayout(1, false);
		gl_composite_Enunciado2.horizontalSpacing = 2;
		gl_composite_Enunciado2.marginHeight = 2;
		gl_composite_Enunciado2.marginWidth = 2;
		gl_composite_Enunciado2.verticalSpacing = 2;
		composite_Enunciado2.setLayout(gl_composite_Enunciado2);
		
		compositeFechaFin = new Composite(composite_Enunciado2, SWT.NONE);
		compositeFechaFin.setLayoutData(new GridData(SWT.FILL, SWT.FILL, true, false, 1, 1));
		GridLayout gl_compositeFechaFin = new GridLayout(2, false);
		gl_compositeFechaFin.verticalSpacing = 2;
		gl_compositeFechaFin.horizontalSpacing = 2;
		gl_compositeFechaFin.marginWidth = 0;
		gl_compositeFechaFin.marginHeight = 0;
		compositeFechaFin.setLayout(gl_compositeFechaFin);
		Label lblTerminaEtiqueta = new Label(compositeFechaFin, SWT.NONE);
		lblTerminaEtiqueta.setLayoutData(new GridData(SWT.RIGHT, SWT.CENTER, false, false, 1, 1));
		lblTerminaEtiqueta.setText(PCuaderno.MiPCuaderno.mensajes.getString("Programacion_LblTerminaEtiqueta_Text"));
		lblTermina = new Label(compositeFechaFin, SWT.NONE);
		GridData gd_lblTermina = new GridData(SWT.FILL, SWT.CENTER, false, false, 1, 1);
		gd_lblTermina.widthHint = 150;
		gd_lblTermina.minimumWidth = 150;
		lblTermina.setLayoutData(gd_lblTermina);
		lblTermina.setToolTipText(PCuaderno.MiPCuaderno.mensajes.getString("Programacion_LblTermina_ToolTip"));
		
		compositeParcial = new Composite(composite_Enunciado2, SWT.NONE);
		compositeParcial.setLayoutData(new GridData(SWT.FILL, SWT.FILL, true, false, 1, 1));
		GridLayout gl_compositeParcial = new GridLayout(2, false);
		gl_compositeParcial.horizontalSpacing = 2;
		gl_compositeParcial.verticalSpacing = 2;
		gl_compositeParcial.marginWidth = 0;
		gl_compositeParcial.marginHeight = 0;
		compositeParcial.setLayout(gl_compositeParcial);
		
		lblTerminaParcialEtiqueta = new Label(compositeParcial, SWT.NONE);
		lblTerminaParcialEtiqueta.setLayoutData(new GridData(SWT.RIGHT, SWT.CENTER, false, false, 1, 1));
		lblTerminaParcialEtiqueta.setText(PCuaderno.MiPCuaderno.mensajes.getString("Programacion_LblTerminaParcial_Text"));
		lblTerminaParcialEtiqueta.setToolTipText(PCuaderno.MiPCuaderno.mensajes.getString("Programacion_LblTerminaParcial_ToolTip"));
		
		lblTerminaParcial = new Label(compositeParcial, SWT.NONE);
		GridData gd_lblTerminaParcial = new GridData(SWT.LEFT, SWT.CENTER, false, false, 1, 1);
		gd_lblTerminaParcial.minimumWidth = 20;
		gd_lblTerminaParcial.widthHint = 20;
		lblTerminaParcial.setLayoutData(gd_lblTerminaParcial);
		lblTerminaParcial.setToolTipText(PCuaderno.MiPCuaderno.mensajes.getString("Programacion_LblTerminaParcial_ToolTip"));
		listEvaluables = new List(grpDistTemporal, SWT.BORDER | SWT.V_SCROLL);
		listEvaluables.setToolTipText(PCuaderno.MiPCuaderno.mensajes.getString("Programacion_ListEvaluables_ToolTip"));
		GridData gd_listEvaluables = new GridData(SWT.FILL, SWT.FILL, true, true, 1, 3);
		gd_listEvaluables.minimumWidth = 75;
		gd_listEvaluables.widthHint = 150;
		listEvaluables.setLayoutData(gd_listEvaluables);
		listConIdEvaluables = new ListConId(listEvaluables);
		grpPorImpartir = new Group(grpDistTemporal, SWT.NONE);
		GridData gd_grpPorImpartir = new GridData(SWT.FILL, SWT.BOTTOM, true,false, 2, 2);
		gd_grpPorImpartir.minimumWidth = 100;
		gd_grpPorImpartir.widthHint = 100;
		grpPorImpartir.setLayoutData(gd_grpPorImpartir);
		GridLayout gl_grpPorImpartir = new GridLayout(2, false);
		gl_grpPorImpartir.verticalSpacing = 2;
		gl_grpPorImpartir.marginWidth = 2;
		gl_grpPorImpartir.marginHeight = 2;
		gl_grpPorImpartir.horizontalSpacing = 2;
		grpPorImpartir.setLayout(gl_grpPorImpartir);
		grpPorImpartir.setText(PCuaderno.MiPCuaderno.mensajes.getString("Programacion_GrpPorImpartir_Text"));
			Label lblDisponibleEtiqueta = new Label(grpPorImpartir, SWT.NONE);
			lblDisponibleEtiqueta.setText(PCuaderno.MiPCuaderno.mensajes.getString("Programacion_LblDisponibleEtiqueta_Text"));
			lblDisponible = new Label(grpPorImpartir, SWT.NONE);
			lblDisponible.setToolTipText(PCuaderno.MiPCuaderno.mensajes.getString("Programacion_LblDisponible_ToolTip"));
			GridData gd_lblDisponible = new GridData(SWT.FILL, SWT.CENTER, true,false, 1, 1);
			gd_lblDisponible.widthHint = 60;
			gd_lblDisponible.minimumWidth = 60;
			lblDisponible.setLayoutData(gd_lblDisponible);
			lblDisponible.setText("99999/99999");
			Label lblRequeridoEtiqueta = new Label(grpPorImpartir, SWT.NONE);
			lblRequeridoEtiqueta.setText(PCuaderno.MiPCuaderno.mensajes.getString("Programacion_LblRequeridoEtiqueta_Text"));
			lblRequerido = new Label(grpPorImpartir, SWT.NONE);
			lblRequerido.setToolTipText(PCuaderno.MiPCuaderno.mensajes.getString("Programacion_LblRequerido_ToolTip"));
			GridData gd_lblRequerido = new GridData(SWT.FILL, SWT.CENTER, true,false, 1, 1);
			gd_lblRequerido.widthHint = 60;
			gd_lblRequerido.minimumWidth = 60;
			lblRequerido.setLayoutData(gd_lblRequerido);
			lblRequerido.setText("99999/99999");
			buttonReajustar = new Button(grpPorImpartir, SWT.NONE);
			buttonReajustar.setLayoutData(new GridData(SWT.FILL, SWT.CENTER, false, false, 2, 1));
			buttonReajustar.setText(PCuaderno.MiPCuaderno.mensajes.getString("Programacion_btnReajustar_Text"));
			buttonReajustar.setToolTipText(PCuaderno.MiPCuaderno.mensajes.getString("Programacion_btnReajustar_ToolTip"));
			buttonReajustar.addSelectionListener(new SelectionAdapter() {
				public void widgetSelected(SelectionEvent e) {
					if (PCuaderno.noti) PCuaderno.MiPCuaderno.notificar("btnReajustar");
					if (PCuaderno.MiPCuaderno.bbdd.consultarUHvacio(MateriaClase.getIdMateriaClaseDeTrabajo())) {
						PCuaderno.MiPCuaderno.error(PCuaderno.MiPCuaderno.mensajes.getString("Programacion_ButtonReajustar_Error_NoSchedule"));
					} else if (Parcial.numeroParciales()<=0) {
						PCuaderno.MiPCuaderno.error(PCuaderno.MiPCuaderno.mensajes.getString("Programacion_ButtonReajustar_Error_NoPartial"));
					} else if (disponibleTotal<=treeConIdIndice.minutosRequeridoHastaFinNodo(treeConIdIndice.selecionado())) {
						PCuaderno.MiPCuaderno.error(PCuaderno.MiPCuaderno.mensajes.getString("Programacion_ButtonReajustar_Error_NoAvailable"));
					} else {
						String m=PCuaderno.MiPCuaderno.mensajes.getString("Programacion_BtnReajustar_Preg_Seguro");
						int buttonID = PCuaderno.MiPCuaderno.pregunta(m);
						if (buttonID == SWT.OK) {
							treeConIdIndice.reajustarMinutosParaNodoSiguientesEnMateria(
									treeConIdIndice.getNodo(treeConIdIndice.getIdSeleccionado()),
									MateriaClase.getIdMateriaDeTrabajo(),
									MateriaClase.getIdClaseDeTrabajo());
							actualizarTiempos();
							actualizarDatosNodo();
						}
					}
				}
			});
		new Label(grpDistTemporal, SWT.NONE);
		new Label(grpDistTemporal, SWT.NONE);
		labelEvaluables = new Label(grpDistTemporal, SWT.NONE);
		labelEvaluables.setLayoutData(new GridData(SWT.RIGHT, SWT.BOTTOM, false, false, 1, 1));
		labelEvaluables.setText(PCuaderno.MiPCuaderno.mensajes.getString("Programacion_LblEvaluables_Text"));
	}

	// -------------------------------------------------------------------------------------------------
	

	public void actualizarDatosNodo() {
		if (PCuaderno.noti) PCuaderno.MiPCuaderno.notificar("()",false);
		TreeItem seleccionado = treeConIdIndice.selecionado();
		TreeItem nodoHermanoAnterior = treeConIdIndice.getHermanoAnterior(seleccionado);
		TreeItem nodoHermanoPosterior = treeConIdIndice.getHermanoPosterior(seleccionado);
		TreeItem nodoPadre = treeConIdIndice.getPadre(seleccionado);
		btnAdelantarNodo.setEnabled(nodoHermanoAnterior != null);
		btnRetrasarNodo.setEnabled(nodoHermanoPosterior != null);
		btnBajarNodo.setEnabled(nodoHermanoPosterior != null || nodoHermanoAnterior != null);
		btnSubirNodo.setEnabled(nodoPadre != null);
		btnCrearHermano.setEnabled(seleccionado != null);
		btnBorrarNodo.setEnabled(seleccionado != null);
		btnCrearNodoHijo.setEnabled(comboConIdMateria.idSeleccionado()!=null);
		if (seleccionado != null && comboConIdClase.idSeleccionado()!=null) {
			Vector<Vector<String>> infoNodo = PCuaderno.MiPCuaderno.bbdd.consultarProgramacionNodo(treeConIdIndice.getIdSeleccionado());
			TextoDemorado.modificaSinActualizar(textSumario, infoNodo.get(0).get(5));
			Integer duracion=treeConIdIndice.minutosNodoSinHijos(seleccionado);
			if (duracion==null) duracion=0;
			TextoDemorado.modificaSinActualizar(textDuracion, duracion.toString());
			if (treeConIdIndice.seleccionadoTieneHijos()) {
				textDuracion.setEnabled(false);
				buttonAhora.setEnabled(false);
			} else {
				if (treeConIdIndice.minutosRequeridosPorNodoParaAcabarAhoraEnDisponible(seleccionado)>=0)
					buttonAhora.setEnabled(true);
				else
					buttonAhora.setEnabled(false);
			}
		} else {
			textSumario.setEnabled(false);
			textSumario.setText("");
			textDuracion.setEnabled(false);
			textDuracion.setText("");
			buttonAhora.setEnabled(false);
		}
		btnImportar.setEnabled(comboConIdClase.idSeleccionado()!=null);
		actualizarTerminaNodo();
		listConIdEvaluables.rellenarEvaluablesParaNodo(treeConIdIndice.getId(seleccionado));
		if (PCuaderno.noti) PCuaderno.MiPCuaderno.notificar("()",true);
	}

	public void actualizarTerminaNodo() {
		if (PCuaderno.noti) PCuaderno.MiPCuaderno.notificar("()",false);
		TreeItem seleccionado = treeConIdIndice.selecionado();
		//System.out.println("seleccionado="+seleccionado);
		if (seleccionado != null) {
			Integer minutos=treeConIdIndice.minutosRequeridoHastaFinNodo(seleccionado);
			Integer minutosInicio=treeConIdIndice.minutosRequeridoHastaInicioNodo(seleccionado);
			if (minutos>0) minutos--;
			Calendar fecha=MateriaClase.fechaDisponibleParaMinutosRequeridosEnMateriaClaseTrabajo(
					minutos);
			Calendar fechaInicio=MateriaClase.fechaDisponibleParaMinutosRequeridosEnMateriaClaseTrabajo(
					minutosInicio);
			String tFecha=Fecha.formaFechaDiaHora(fecha);
			if (tFecha==null) tFecha = "";
			lblTermina.setText(tFecha);
			String tParcial="";
			if (fechaInicio!=null) tParcial=String.valueOf(Parcial.getParcial(fechaInicio));
			//System.out.println("Idnodo "+treeConIdIndice.getId(seleccionado)+": "+seleccionado);
			//System.out.println("minutosRequeridos hasta inicio nodo "+minutosInicio);
			//System.out.println("FechaEnDisponible inicio nodo "+Fecha.formaFechaDiaHora(fechaInicio));
			//System.out.println("Idnodo arbolDeTrabajo "+PCuaderno.MiPCuaderno.arbolDeTrabajo.idNodoParaMinutosRequeridos(minutosInicio+1));
			lblTerminaParcial.setText(tParcial);
		} else {
			lblTermina.setText("");
			lblTerminaParcial.setText("");
		}
		if (PCuaderno.noti) PCuaderno.MiPCuaderno.notificar("()",true);
	}

	public void actualizarRequeridoTotal() {
		requeridoTotal = treeConIdIndice.minutosTotal();
		Integer requQueda = (requeridoTotal - (disponibleTotal - dispQueda));
		lblRequerido.setText(((requQueda>0)?requQueda:"0")+"/"+requeridoTotal);
		Color color = Display.getCurrent().getSystemColor((disponibleTotal>requeridoTotal)?SWT.COLOR_DARK_YELLOW:
			(disponibleTotal.equals(requeridoTotal))?SWT.COLOR_DARK_GREEN:SWT.COLOR_DARK_RED);
		lblRequerido.setForeground(color);
	}
	public void actualizarDisponibleTotal() {
		disponibleTotal = MateriaClase.minutosDisponiblesEnMateriaClaseTrabajoDesdeFecha(null);
		dispQueda = MateriaClase.minutosDisponiblesEnMateriaClaseTrabajoDesdeFecha(Calendar.getInstance());
		lblDisponible.setText(dispQueda + "/" + disponibleTotal);
		Integer requQueda = (requeridoTotal - (disponibleTotal - dispQueda));
		lblRequerido.setText(((requQueda>0)?requQueda:"0")+"/"+requeridoTotal);
		Color color = Display.getCurrent().getSystemColor((disponibleTotal>requeridoTotal)?SWT.COLOR_DARK_YELLOW:
			(disponibleTotal.equals(requeridoTotal))?SWT.COLOR_DARK_GREEN:SWT.COLOR_DARK_RED);
		lblRequerido.setForeground(color);
	}
	public void actualizarTiempos() {
		actualizarDisponibleTotal();
		actualizarRequeridoTotal();
	}
	public void actualizarClases() {
		comboConIdClase.rellenarClases(comboConIdMateria.idSeleccionado(),null,null);
	}
}
